/*
 * Copyright (C) Volition, Inc. 1999.  All rights reserved.
 *
 * All source code herein is the property of Volition, Inc. You may not sell 
 * or otherwise commercially exploit the source or things you created based on
 * the source.
 */

/*
 * $Logfile: /Freespace2/code/Localization/strings_tbl_fs1.cpp $
 * $Revision: 311 $
 * $Date: 2010-02-08 09:09:26 +0100 (Mon, 08 Feb 2010) $
 * $Author: taylor $
 *
 * copy of strings.tbl modified for FS1
 *
 * $Log$
 * Revision 1.2  2006/04/26 19:40:15  taylor
 * text changes to match the original FS1 wording
 *
 * Revision 1.1  2005/10/01 21:35:51  taylor
 * various FS1 related changes, removes need to extra fs1.vp file
 *
 *  
 * $NoKeywords: $
 */

#ifdef MAKE_FS1

#include "pstypes.h"
#include "localize.h"


const char *FS1_trans[LCL_NUM_LANGUAGES_FS1][LCL_NUM_STRINGS_FS1] =
{
	// English
	{
		"Player ship changed to %s",
		"Changed player target to %s",
		"Soundtrack changed to: %s",
		"Event music is not playing",
		"Framerate delay increased to %i milliseconds per frame.",
		"Framerate delay decreased to %i milliseconds per frame.",
		"Countermeasure firing: %s",
		"ENABLED",
		"DISABLED",
		"You whacked yourself down to %7.3f percent hull.\n",
		"You are %s",
		"now INVULNERABLE!",
		"no longer invulnerable...",
		"Player's target [%s] is %s",
		"Spewing debug info about object #%d",
		"Weapon energy and missile count will always be at full ALL SHIPS!",
		"Weapon energy and missile count will always be at full for player",
		"Normal weapon energy system / missile count restored",
		"Secondary Weapon forced to %s",
		"Primary Weapon forced to %s",
		"Event music disabled",
		"Event music enabled",
		"Detail level set to %+d\n",
		"Frame Rate test started",
		"Species of target changed to: %s",
		"Skill level set to %s.",
		"No target to add/remove from set %d.",
		"%s added to set %d. (F%d)",
		"&Yes, Quit",
		"Yes, &Restart",
		"Do you really want to end the mission?",
		"Cheats enabled.",
		"All movies available in Tech Room",
		"This ship has no secondary weapons",
		"Secondary weapon set to normal fire mode",
		"Secondary weapon set to dual fire mode",
		"External camera is locked, controls will move ship",
		"External camera is free, controls will move the camera, not the ship",
		"Radar range set to %s",
		"** WARNING ** Collision danger.  Warpout not activated.",
		"Engine failure.  Cannot engage warp drive.",
		"&Retry",
		"&Ignore",
		"&Quit Game",
		"Warning\nFailed to save pilot file.  You may be out of disk space.  If so, you should press Alt-Tab, free up some disk space, then come back and choose retry.\n",
		"'",
		"'s",
		"&No",
		"&Yes",
		"Warning\nA duplicate pilot exists\nOverwrite?",
		"*All Time Stats",
		"Primary weapon shots:",
		"Primary weapon hits:",
		"Primary friendly hits:",
		"Primary hit %:",
		"%.1f%%",
		"Primary friendly hit %:",
		"Secondary weapon shots:",
		"Secondary weapon hits:",
		"Secondary friendly hits:",
		"Secondary hit %:",
		"Secondary friendly hit %:",
		"Total kills:",
		"Assists:",
		"*Kills by Ship Type",
		"Warning!\n\nAre you sure you wish to delete this pilot?",
		"You must create a single player pilot.",
		"You must create a multi player pilot.",
		"multiplayer",
		"single player",
		"This will overwrite your %s pilot.  Proceed?",
		"%d of %d",
		"mdls",
		"pause",
		"wpns",
		"god view",
		"plyr view",
		"prev view",
		"zoom in",
		"zoom out",
		"hit ESC to exit",
		"Cannot warp out at this time.",
		"Unable to engage warp... ship must be able to reach %.1f km/s",
		"passengers:\n   %s",
		"cargo: %s",
		"Scanned",
		"cargo: <unknown>",
		"not scanned",
		"cargo: inspecting",
		"scanning",
		"missile",
		"laser fire",
		"%s was killed by a missile shockwave",
		"%s was killed by a shockwave from %s exploding",
		"%s was killed by %s",
		"%s was killed by a blast from %s exploding",
		"%s was killed by a collision with %s",
		"%s was killed by a collision with debris",
		"%s was killed by a collision with an asteroid",
		"%s was killed by unknown causes",
		"You have killed yourself",
		"top view",
		"rear view",
		"left view",
		"right view",
		"Quick Start Mission",
		"Return To Flight Deck",
		"Return To Briefing",
		"Observer Mode",
		"Respawn",
		"Warning\nThis will cause all progress in your\ncurrent campaign to be lost",
		"Demo Campaign Is Over.  Would you like to play the campaign again?",
		"The campaign is over.  To replay the campaign, either create a new pilot or restart the campaign in the campaign room.",
		"Warning\nThis will cause all progress in campaign ",
		"Mission Stats",
		"Total kills",
		"Primary weapon shots",
		"Primary weapon hits",
		"Primary friendly hits",
		"Primary hit %%",
		"Primary friendly hit %%",
		"Secondary weapon shots",
		"Secondary weapon hits",
		"Secondary friendly hits",
		"Secondary hit %%",
		"Secondary friendly hit %%",
		"Assists",
		"Player Deaths",
		"All Time Stats",
		", ",
		"no binding",
		" - ",
		"Page %d of %d",
		"Basic Keys",
		"Function Keys",
		"F1",
		"context-sensitive help",
		"F2",
		"options screen (available anywhere in game)",
		"F3",
		"hotkey assignment",
		"F4",
		"HUD message scroll-back",
		"F5...F12",
		"hotkeys",
		"Shift-Esc",
		"quit FreeSpace immediately",
		"Movement Keys",
		"Basic Targeting Keys",
		"Advanced Targeting Keys",
		"Select target assigned to that hotkey",
		"Shift-F5...F12",
		"Add/remove target from that hotkey",
		"Alt-Shift-F5...F12",
		"Clear that hotkey",
		"Messaging Keys",
		"send specified order to these target(s)",
		"Weapon Keys",
		"Energy Management Keys",
		"Miscellaneous Keys",
		"ESC",
		"invoke abort mission popup",
		"Pause",
		"pause game",
		"Print Scrn",
		"take screen shot",
		"View Keys",
		"Multiplayer Keys",
		"Ingame messaging keys (tap for text, hold for voice)",
		"Attempt to load the mission failed",
		"FreeSpace Demo",
		"FreeSpace",
		"This version of Freespace has been compiled for\n\n",
		"\n\nPress OK to continue.\n",
		"DO NOT DISTRIBUTE!",
		"This version of Freespace has been compiled for",
		"Hit any key to continue.",
		"Your fighter is running out of oil.  Please check under the\nhood and add more if necessary",
		"Freespace is very tired.  It is shutting down to get some rest.",
		"Mission time remaining: %d seconds",
		"Net bytes read: %d",
		"Net bytes written: %d",
		"External view of player ship.",
		"View from inside player ship.",
		"jump node",
		"Viewing %s%s\n",
		"from ",
		"Viewing from observer\n",
		"Viewing from self\n",
		"Quick Start Mission",
		"Return To Flight Deck",
		"Return To Briefing",
		"You have died",
		"FreeSpace has detected that you only have %dMB of free memory.\n\nFreeSpace requires at least 32MB of memory to run.  If you think you have more than %dMB of physical memory, ensure that you aren't running SmartDrive (SMARTDRV.EXE).  Any memory allocated to SmartDrive is not usable by applications\n\nPress 'OK' to continue running with less than the minimum required memory\n",
		"Not Enough RAM",
		"FreeSpace has detected that you only have %dMB of free memory.\n\nFreeSpace requires at least 32MB of memory to run.  If you think you have more than %dMB of physical memory, ensure that you aren't running SmartDrive (SMARTDRV.EXE).  Any memory allocated to SmartDrive is not usable by applications\n",
		"FreeSpace requires virtual memory to run.\r\n",
		"No Virtual Memory",
		"Not enough memory to run Freespace.\r\nTry closing down some other applications.\r\n",
		"Not Enough Memory",
		"Sorry, this feature is available only in the retail version",
		"%d:",
		"FreeSpace CD not found\n\nInsert a FreeSpace CD to continue",
		"Movie not found\n\nInsert FreeSpace CD #%d to continue",
		"Unable to play movie %s.",
		"Conflict!",
		"Canceled",
		"That is a non-bindable key.  Please try again.",
		"?",
		"Control conflicts with:",
		"More...",
		"None",
		", ",
		"Event music is not playing",
		"soundtrack: %s [%s]",
		"x%.1f",
		"x%.0f",
		"message",
		"damage",
		"%d%%",
		"Hull Integrity",
		"<none>",
		"dead",
		"kills:",
		"support",
		"aborted",
		"complete",
		"repairing",
		"rearming",
		"obstructed",
		"warping in",
		"busy",
		"dock in:",
		"subspace drive",
		"engaged",
		"downloading new",
		"orders...",
		"primary objective",
		"secondary objective",
		"bonus objective",
		"failed (%d/%d)",
		"complete (%d/%d)",
		"failed",
		"[voice denied]",
		"[recording voice]",
		"[playing voice]",
		"2000 M",
		"10,000 M",
		"infinity",
		"lead indicator",
		"target orientation",
		"closest attacking hostile",
		"current target direction",
		"mission time",
		"reticle",
		"throttle",
		"radar",
		"target monitor",
		"center of reticle",
		"extra target info",
		"target shield",
		"player shield",
		"power management",
		"auto-target icon",
		"auto-speed-match icon",
		"weapons display",
		"monitoring view",
		"directives view",
		"threat gauge",
		"afterburner energy",
		"weapons energy",
		"weapon linking",
		"target hull/shield icon",
		"offscreen indicator",
		"comm video",
		"damage display",
		"message output",
		"locked missile direction",
		"countermeasures",
		"objective notify",
		"wingmen status",
		"offscreen range",
		"kills gauge",
		"attacking target count",
		"D",
		"monitoring",
		"Escort view enabled",
		"Escort view disabled",
		"Escort list is full with %d ships",
		"Current time",
		"",
		"",
		"0",
		"Ships",
		"Wings",
		"All Fighters",
		"Reinforcements",
		"Rearm/Repair Subsys",
		"Abort Rearm",
		"Destroy my target",
		"Disable my target",
		"Disarm my target",
		"Destroy subsystem",
		"Protect my target",
		"Ignore my target",
		"Form on my wing",
		"Cover me",
		"Engage enemy",
		"Capture my target",
		"Rearm me",
		"Abort rearm",
		"Depart",
		"[pgup]",
		"[pgdn]",
		"No valid items",
		"Not allowed to message",
		"Message What",
		"Select Ship",
		"Select Wing",
		"Select Ship/Wing",
		"(*)",
		"What Command",
		"No target selected.",
		"Targeting subsystem %s.",
		"Deactivating sub-system targeting",
		"Deactivating targeting system",
		"%d%%",
		"cm.",
		"weapons",
		"<none>",
		"Targeting is disabled due to sensors damage",
		"Messaging is restricted due to communications damage",
		"No support ships in area.  Use messaging to call one in.",
		"communication",
		"comm",
		"navigation",
		"nav",
		"no orders",
		"time to: ",
		"Docked: %s",
		"d: %.0f",
		"%d%%",
		"DISABLED",
		"DISRUPTED",
		"dis",
		"ok",
		"dmg",
		"crt",
		"debris",
		"unknown",
		"d: %.0f%s",
		"s: %.0f%s",
		"wingmen",
		"Exit Freespace",
		"Barracks - Manage your Freespace pilots",
		"Ready room - Start or continue a campaign",
		"Tech room - View specifications of Freespace ships and weaponry",
		"Options - Change your Freespace options",
		"Campaign Room - View all available campaigns",
		"Multiplayer - Start or join a multiplayer game",
		"You have not defined your type of Internet connection.  Please run the Launcher, hit the setup button, and go to the Network tab and choose your connection type.",
		"Winsock is not installed.  You must have TCP/IP and Winsock installed to play multiplayer FreeSpace.",
		"You have selected TCP/IP for multiplayer Freespace, but the TCP/IP protocol was not detected on your machine.",
		"You have selected Dial Up Networking as your type of connection to the Internet.  You are not currently connected.  You must connect to your ISP before continuing on past this point.",
		"You have indicated that you use a LAN for networking.  You also appear to be dialed into your ISP.  Please disconnect from your service provider, or choose ",
		"Exit Game?",
		"Campaign Room not valid for multiplayer pilots",
		"Not a valid multiplayer pilot!!",
		"Load Mission not valid for multiplayer pilots",
		"Quick Start not valid for multiplayer pilots",
		"Skill level set to %s.",
		"Press F1 for help",
		"You can't change your skill level while in the middle of a mission.",
		"You can't change your skill level here for multiplayer games.  Sklll level is set by the host of the game in the host options screen.",
		"Exit Game?",
		"Cannot use HUD config when an observer!",
		"Single Player Mode",
		"Multiplayer Mode",
		"You must select a valid pilot first",
		"You already have the maximum # of pilots!",
		"Error creating new pilot file!",
		"Type Callsign and Press Enter",
		"Warning!\n\nAre you sure you wish to delete this pilot?",
		"Are you sure you want to delete this pilot?",
		"Descent: FreeSpace - The Great War, Copyright %c 1998, Volition, Inc.",
		"All rights reserved",
		"Ip string is invalid!",
		"Cancel",
		"Verifying ip address",
		"Max # of IP addresses reached!",
		"Error trying to playback recorded voice! Check your hardware",
		"Cannot test mic while in a multiplayer game!",
		"DirectSoundCapture could not be initialized. To initialize DirectSoundCapture your sound card must be full duplex and your sound card drivers must support DirectSoundCapture",
		"Packet Overflow",
		"Stage %d of %d",
		"Please review your objectives for this mission.",
		"Primary",
		"Secondary",
		"Bonus",
		"*Primary Objectives",
		"*Secondary Objectives",
		"*Bonus Objectives",
		"Friendly ships",
		"Enemy ships",
		"Destroyed",
		"  Kill: ",
		"Arrived",
		"Arrived (wave %d)",
		"Departed",
		"docked with ",
		"Subsystem ",
		" destroyed",
		"Undocked with ",
		"Disabled",
		"Disarmed",
		" called for rearm",
		" aborted rearm",
		"Called in as reinforcement",
		"Cargo revealed: ",
		"%s objective ",
		"satisfied.",
		"failed.",
		"directives",
		"Training failed",
		"&Bind Control",
		"&Abort mission",
		"Warning\nYou have no control bound to the action '%s'.  You must do so before you can continue with your training.",
		"<%s was kicked>",
		"Close",
		"Skip Training\n\n\n\nAre you sure you want to skip this training mission?",
		"No Briefing exists for mission: %s",
		"asteroid",
		"jump node",
		"unknown",
		" class",
		"Medal",
		"Rank",
		"Badge",
		"(O)",
		"Your career is over, Traitor!  You can't accept new missions!",
		"You are a cheater.  You cannot accept this mission!",
		"You have failed this mission and cannot accept.  What do you you wish to do instead?",
		"Return to &Debriefing",
		"Go to &Flight Deck",
		"&Replay Mission",
		"%d of %d",
		"Mission Time",
		"Mission Kills by Ship Type",
		"All-time Kills by Ship Type",
		"(No ship kills this mission)",
		"(No ship kills)",
		"&Replay",
		"If you choose to replay this mission, you will be required to complete it again before proceeding to future missions.\n\nIn addition, any statistics gathered during this mission will be discarded if you choose to replay.",
		"Your performance was excellent.  We have no recommendations for you.",
		"&Yes",
		"&No, retry later",
		"Accept this mission outcome?",
		"Because this mission was a failure, you must replay this mission when you continue your campaign.\n\nReturn to the Flight Deck?",
		"No Debriefing for mission: %s",
		"More",
		"At least one ship must be selected before proceeding to weapons loadout",
		"Player ship has no weapons",
		"Player %s must select a place in player wing",
		"",
		"Stage %d of %d",
		"Too close to planet.  Taking damage!",
		"Warpout sequence aborted.",
		"2k",
		"10k",
		"Very Easy",
		"Easy",
		"Medium",
		"Hard",
		"Insane",
		"attack ",
		"dock ",
		"waypoints",
		"destroy ",
		"form on ",
		"undock ",
		"guard ",
		"disable ",
		"disarm ",
		"evade ",
		"rearm ",
		"No more countermeasure charges.",
		"Detonated %s!",
		"Too far from target to acquire lock",
		"Cannot fire %s without a lock",
		"Cannot fire %s due to weapons system damage",
		"This ship has no primary weapons",
		"This ship has only one primary weapon: %s",
		"This ship has no secondary weapons",
		"This ship has only one secondary weapon: %s",
		" Wing",
		"no orders",
		"atk %s %s",
		"Unknown",
		"Subspace node activated",
		"Your %s subsystem has been destroyed",
		"Conflict: FreeSpace - Darkness Rising, Copyright %c 1998, Volition, Inc.",
		"Descent: FreeSpace - Darkness Rising, Copyright %c 1998, Volition, Inc.",
		"Conflict: FreeSpace - The Great War, Copyright %c 1998, Volition, Inc.",
		"",
		"",
		"",
		"",
		"Target Next Ship",
		"Target Previous Ship",
		"Target Next Closest Hostile Ship",
		"Target Previous Closest Hostile Ship",
		"Toggle Auto Targeting",
		"Target Next Closest Friendly Ship",
		"Target Previous Closest Friendly Ship",
		"Target Ship in Reticle",
		"Target Target's Nearest Attacker",
		"Target Last Ship to Send Transmission",
		"Stop Targeting Ship",
		"Target Subsystem in Reticle",
		"Target Next Subsystem",
		"Target Previous Subsystem",
		"Stop Targeting Subsystem",
		"Match Target Speed",
		"Toggle Auto Speed Matching",
		"Fire Primary Weapon",
		"Fire Secondary Weapon",
		"Cycle Forward Primary Weapon",
		"Cycle Backward Primary Weapon",
		"Cycle Secondary Weapon Bank",
		"Cycle Secondary Weapon Firing Rate",
		"Launch Countermeasure",
		"Forward Thrust",
		"Reverse Thrust",
		"Bank Left",
		"Bank Right",
		"Pitch Forward",
		"Pitch Backward",
		"Turn Left",
		"Turn Right",
		"Set Zero Throttle",
		"Set Max Throttle",
		"Set One-Third Throttle",
		"Set Two-Thirds Throttle",
		"Increase Throttle 5 Percent",
		"Decrease Throttle 5 Percent",
		"Attack My Target",
		"Disarm My Target",
		"Disable My Target",
		"Attack my Subsystem",
		"Capture My Target",
		"Engage Enemy",
		"Form on my Wing",
		"Ignore my Target",
		"Protect my Target",
		"Cover me",
		"Return to base",
		"Rearm me",
		"Target Closest Attacking Ship",
		"Chase View",
		"External View",
		"Toggle External Camera Lock",
		"Free Look View",
		"Current Target View",
		"Increase View Distance",
		"Decrease View Distance",
		"Center View",
		"View Up",
		"View Rear",
		"View Left",
		"View Right",
		"Cycle Radar Range",
		"Communications Menu",
		"Show Objectives",
		"Enter Subspace (End Mission)",
		"Target Target's Target",
		"Afterburner",
		"Increase Weapon Energy",
		"Decrease Weapon Energy",
		"Increase Shield Energy",
		"Decrease Shield Energy",
		"Increase Engine Energy",
		"Decrease Engine Energy",
		"Equalize Energy Settings",
		"Equalize Shield",
		"Augment Forward Shield",
		"Augment Rear Shield",
		"Augment Left Shield",
		"Augment Right Shield",
		"Transfer Energy Laser->Shield",
		"Transfer Energy Shield->Laser",
		"Show Damage Popup Window",
		"Bank When Pressed",
		"Show NavMap",
		"Add or Remove Escort",
		"Clear Escort List",
		"Target Next Escort Ship",
		"Target Closest Repair Ship",
		"Target Next Uninspected Cargo",
		"Target Previous Uninspected Cargo",
		"Target Newest Ship In Area",
		"Target Next Live Turret",
		"Target Previous Live Turret",
		"Target Next Hostile Bomb",
		"Target Previous Hostile Bomb",
		"(Multiplayer) Message All",
		"(Multiplayer) Message Friendly",
		"(Multiplayer) Message Hostile",
		"(Multiplayer) Message Target",
		"(Multiplayer) Observer zoom to target",
		"Increase time compression",
		"Decrease time compression",
		"Toggle high HUD contrast",
		"(Multiplayer) Toggle network info",
		"(Multiplayer) Self destruct",
		"",
		"",
		"",
		"",
		"",
		"",
		"Alpha channel textures",
		"Missing Features",
		"16-bpp RGB textures",
		"Your video card is missing the following features required by FreeSpace:\r\n\r\n",
		"Texture blending mode = Modulate\r\n",
		"Source blending mode = SRCALPHA or BOTHSRCALPHA\r\n",
		"Destination blending mode = INVSRCALPHA or BOTHINVSRCALPHA\r\n",
		"At least 1 MB of available video memory required.",
		"> 1 sec",
		"%d ms",
		"K: ",
		"A: ",
		"Jump Node %d",
		"A %s is unable to carry %s weaponry",
		"Unrecognized command",
		"** CTCP Message from %s (%s)",
		"** %s has joined %s",
		"*** %s has kicked %s from channel %s (%s)",
		"*** %s is now known as %s",
		"**Error: %s is not online!",
		"Your nickname contains invalid characters",
		"Cancel",
		"Contact lost with server.  Stopping simulation until contact reestablished.  Press Cancel to exit game.",
		"The Campaign Is Complete. Thank You For Playing",
		"Campaign ship/weapon pool\n",
		"&Cancel",
		"Waiting for clients to disconnect",
		"Warning - quitting will end the game for all players!",
		"Are you sure you want to quit?",
		"<Team captains have left>",
		"<The server has ended the game>",
		"You have been kicked",
		"The server has left the game",
		"Your mission file has been rejected by the server",
		"The game has ended while you were ingame joining",
		"You have waited too long to select a ship",
		"Contact with server has been lost",
		"Failed to connect to server on reliable socket",
		"Failed to load mission file properly",
		"Unable to create ingame join player ship",
		"Recevied bogus packet data while ingame joining",
		"Server transfer failed (obsolete)",
		"Server encountered errors trying to assign players to ships",
		"Host has left the game, aborting...",
		"Team captain(s) have left the game, aborting...",
		"There was an error receiving the mission file!",
		"Warning, Parallax Online startup failed. Will not be able to play tracker games!",
		"&Cancel",
		"Attempting to validate pilot ...",
		"&Ok",
		"Pilot rejected by Parallax Online!",
		"Successfully created and validated new pilot!",
		"Parallax Online pilot validation succeeded!",
		"&Abort",
		"&Retry",
		"Validation timed out",
		"Sending player stats requests ...",
		"Parallax Online stats store succeeded!",
		"Parallax Online stats store failed!",
		"Attempting to get pilot stats ...",
		"Getting player stats for %s...\n",
		"Updating player stats for %s...\n",
		"Time remaining : %d s\n",
		"Ships packet ack (ingame)\n",
		"Wings packet (ingame)\n",
		"Respawn points packet (ingame)\n",
		"You have been denied the requested ship",
		"<%s was kicked>",
		"Observer Ship",
		"Invalid Image",
		"Waiting",
		"Image Transferring",
		"No Image",
		"No missions flown",
		"ALL : ",
		"FRIENDLY : ",
		"HOSTILE : ",
		"TARGET : ",
		"<SERVER>",
		"ORDER FROM <%s> : ",
		"Attack %s",
		"Disable %s",
		"Protect %s",
		"Ignore %s",
		"Disarm %s",
		"Disable subsystem %s on %s",
		"Form on my wing",
		"Cover me",
		"Engage enemy!",
		"Server transfer",
		"'s game",
		"Server Transfer Complete!",
		"<%s is speaking>",
		"&Ok",
		"An outdated copy of this file exists, but it cannot be overwritten by the server because it is set to be read-only. Change the permissions on this file next time.",
		"Player %s has tried to join, accept y/n ?",
		"%s has entered the game\n",
		"<%s has joined>",
		"<%s was kicked>",
		"%s has left the game",
		"Received mission start\n",
		"Received player settings packet\n",
		"You have been rejected because the game is not in an appropriate state to accept",
		"You have been rejected because this is a Parallax Online game and you are not a registered Parallax Online pilot",
		"You have been rejected because this is a password protected game",
		"You have been rejected because this is a closed game and the mission is in progress",
		"You have been rejected because the netgame is forming and the host has temporarily closed it",
		"You have been rejected because this is a rank limited game and your rank is too high",
		"You have been rejected because this is a rank limited game and your rank is too low",
		"You have been rejected because there is an identical player already in the game",
		"You have been rejected because the game is full",
		"You have been rejected because you are banned from this server",
		"You have been rejected because this game does not allow observers",
		"You cannot join at this time since someone else is currently joining.  Try again shortly.",
		"You cannot join this game because you are running an older version of FreeSpace than the server.  Exit FreeSpace, and choose the 'Update FreeSpace' button in the FreeSpace launcher to download the latest version of FreeSpace.",
		"Weapon slots packet\n",
		"Player %s has tried to join - allow (y/n) ?",
		"C",
		"AI",
		"Class",
		"Type",
		"Length",
		"Max Velocity",
		"%d m/s",
		"Maneuverability",
		"Armor",
		"Gun Mounts",
		"Missile Banks",
		"Manufacturer",
		"Ships/Weapons Locked",
		"Ships/Weapons Are Now Free",
		"Players have not yet been assigned to their ships",
		"You have not yet assigned all necessary ships",
		"There are ships without primary weapons!",
		"There are ships without secondary weapons!",
		"more",
		"Network Error.  Try exiting and restarting FreeSpace to clear the error.  Otherwise, please reboot your machine.",
		"No games found!",
		"No game selected!",
		"Still waiting on previous join request!",
		"Not implemented yet!",
		"> 1 sec",
		" ms",
		"<No game servers found>",
		"Forming",
		"Briefing",
		"Debrief",
		"Paused",
		"Playing",
		"Unknown",
		"Accepted.  Waiting for player data.",
		"Join request timed out!",
		"Joining ingame is currently not allowed for team vs. team games",
		"Sending join request...",
		"Servers on Channel: %s",
		"Warning - You have low object updates selected. A server with low object updates will not be able to handle more than 1 client without performance problems",
		"Low update level caps all bandwidth at ~2000 bytes/second. It is appropriate for clients with 28.8 modems, but is not reccomended for servers. In addition, any clients connecting to this server should use low object updates as well. To change your settings go to the options menu (f2), and select the Multi button",
		"Warning - You have medium object updates selected. A server with medium object updates will not be able to handle more than 1 or 2 clients without performance problems",
		"Medium update level caps all bandwidth at ~4000 bytes/second. It is appropriate for clients with 56.6 modems, but is not reccomended for servers. In addition, any clients connecting to this server should use low object updates as well. To change your settings go to the options menu (f2), and select the Multi button",
		"&Cancel",
		"&Continue",
		"&More info",
		"%s game",
		"Temporary name",
		"Illegal value for a host of your rank (%s)\n",
		"lieutenant",
		"Lt. ",
		"(O)",
		"Please wait until all clients have finished joining",
		"No mission selected!",
		"No campaign selected!",
		"There are too many observers in the game\n\nMax : %d\nCurrently %d\n\nPlease dump a few",
		"There are too many players in the game\n\nMax : %d\nCurrently %d\n\nPlease dump a few",
		"Teams and/or team captains are not assigned properly",
		"You need 1 CD for every 4 players!",
		"NA",
		"Warning\nRespawn count in greater than mission specified max (%d)",
		"Warning\nMission time limit is greater than max allowed (%d)",
		"Warning\nObserver count is greater than max allowed (%d)",
		"Warning\nMission kill limit is greater than max allowed (%d)",
		"Warning\nvoice wait time is greater than max allowed (%d)",
		"Launch",
		"Mission Loading",
		"Ingame Ship Select",
		"Debriefing",
		"Mission Sync",
		"Joining",
		"Joined",
		"Slot Ack",
		"Ship Select",
		"Weapon Select",
		"Waiting",
		"In Mission",
		"Mission Loaded",
		"Data loading",
		"Ready To Enter Mission",
		"Ingame Ships Packet Ack",
		"Ingame Wings Packet Ack",
		"Ingame Respawn Points Ack",
		"Ingame Weapon Slots Ack",
		"Post Briefing Data Block Ack",
		"Flags Ack",
		"Parallax Online Stats Updating",
		"Weapon Slots Ack",
		"Host setup",
		"Debrief accept",
		"Debrief replay",
		"Campaign ship/weapon ack",
		"Mission file xfer %d%%",
		"Mission file xfer",
		"Server performing sync\n",
		"Send update packet\n",
		"Got file signatures\n",
		"Sending update state packet\n",
		"Sent filesig request\n",
		"Sent load packet\n",
		"Loaded mission locally\n",
		"Moving to team select\n",
		"Client performing sync\n",
		"Sending post briefing block information\n",
		"Sending weapon slots information\n",
		"Sending player settings packets\n",
		"Moving into game\n",
		"Sending mission start packet\n",
		"&Accept",
		"&Toss",
		"(Continue Netgame)\nDo you wish to accept these stats?",
		"(Exit Netgame)\nDo you wish to accept these stats?",
		"&Leave",
		"Are you sure you want to leave the netgame before stats are stored?",
		"<stats have been accepted>",
		"<stats have been tossed>",
		"no other network players are present",
		"zapped",
		"caulked",
		"killed",
		"waxed",
		"popped",
		"murdered",
		"bludgeoned",
		"destroyed",
		"iced",
		"obliterated",
		"toasted",
		"roasted",
		"turned into anti-matter",
		"killed like a pig",
		"taught a lesson",
		"slaughtered with impunity",
		"spanked like a naughty boy",
		"skunked",
		"beat senseless",
		"shot up",
		"spaced",
		"hosed",
		"capped",
		"beat down",
		"hit wit da shizzo",
		"sk00led",
		"whooped up",
		"brought to the all-you-can-take whoop ass buffet",
		"served up a whoop ass sandwich...hold the mercy",
		"gibbed by Kayser Sozay's rocket",
		"shot down",
		"given early retirement",
		"instructed",
		"eviscerated",
		"pummelled",
		"eradicated",
		"cleansed",
		"perforated",
		"canned",
		"decompressed",
		"says",
		"bleats",
		"opines",
		"postulates",
		"declares",
		"vomits out",
		"whines",
		"barks",
		"<%s has left>",
		"Dumping %s after prolonged inactivity",
		"[ipx address here]",
		"Standalone Ship",
		"Stats collected for %7.3f seconds\n",
		"Callsign\tBytes read/s\tBytes written/s\n",
		"Couldn't find network stats for %s ... skipping\n",
		"-------------------------\nTotal:\t%d\t%d\n",
		"\n\nPer Packet Statistics\n---------------\nPacket #\tNum Packets Sent\tTotal Bytes\t%% of total\n",
		"[no networking]",
		"# Connections : ",
		"Host connected ? Yes",
		"Host connected ? No",
		"> 1 sec",
		" ms",
		"Standalone Server",
		"Primary Objectives",
		"Secondary Objectives",
		"Bonus Objectives",
		"none",
		"Tree View",
		"The standalone server has failed to log in to Parallax Online!",
		"VMT Warning!",
		"<SERVER> %s",
		"ok",
		"cancel",
		"&apply",
		"Help",
		"Shutdown",
		"Connections",
		"Multi-Player",
		"Player info",
		"God Stuff",
		"Debug",
		"Freespace Standalone",
		"&Create Acct",
		"&Verify Acct",
		"PXO Login not accepted.  You may visit the Parallax Online website to create or verify your login.  Or you may click Cancel to play without using the Parallax Online service.  (You may switch back to Parallax Online from the Options Menu under the Multi tab.)",
		"Retrieving Public Channels",
		"Failed to connect to Parallax Online",
		"You have been kicked",
		"You have been disconnected from the server",
		"Warning\nCould not locate/launch default Internet Browser",
		"No channels!",
		"Already trying to join a channel!",
		"Could not get stats for %s\n(May not be a registered pilot)",
		"Failed to connect to Parallax Online!",
		"Cancel",
		"Logging into Parallax Online",
		"*** %s has left",
		"Connected to Parallax Online",
		"Refreshing Public Channel List",
		"Switching channels",
		"No channel (error while switching)",
		"%s on %s",
		"Parallax Online - No Channel",
		"private message from ",
		"private_message_from ",
		"private message to ",
		"private_message_to ",
		"Type the name of the channel to join/create",
		"Enter user to be found",
		"Searching for %s",
		"User not found",
		"Player is logged in but is not on a channel",
		"Found %s on :",
		"Found %s on a private channel",
		"Getting player stats",
		"Retrieving player tracker id",
		"No missions flown",
		"DirectSound could not be initialized.  If you are running any applications playing sound in the background, you should stop them before continuing.",
		"Could not properly initialize the Microsoft ADPCM codec.\n\nPlease see the readme.txt file for detailed instructions on installing the Microsoft ADPCM codec.",
		"Could not connect to website",
		"Could not find website",
		"Could not send data to website",
		"Could not create version file",
		"Could not get data from website",
		"There was an error verifying your version of Freespace, if you continue, you will not necessarily be up to date",
		"Error opening version info file",
		"A new version of Freespace is available. You must update to the new version to play on PXO\n\nAuto update now?",
		"Verifying Freespace Version",
		"Joining last channel (",
		"Unable to join last channel",
		"Autojoining public channel",
		"Unable to autojoin public channel",
		"You must define your connection speed.  Please run the Launcher, hit the setup button, and go to the Network tab and choose your connection speed.",
		"There was an error parsing the mission file. This file contains illegal data",
		"Unable to copy freespace.exe from update directory to installed directory.  You should copy freespace.exe from the update directory (located in your FreeSpace install directory) to your install directory",
		"Single Mission\n\n%s",
		"Campaign Mission\n\n%s",
		"Loading missions",
		"Loading campaign missions",
		"You cannot join this game because you are not running the Freespace Mission Disk",
		"You have selected a mission or campaign with Mission Disk content, but there are non-Mission Disk players present",
		"&Back",
		"You have selected a mission which is either invalid or unknown to PXO. Your stats will not be saved if you continue",
		"Warning\n\nIf you start a PXO mission by yourself, your stats will not be updated",
		"You were kicked because mission file xfer failed",
		"You were kicked because you do not have the builtin mission",
		"You were kicked because you were ingame joining a game that has ended",
		"<PXO stats store process complete>",
		"<PXO stats store failed for player %s>",
		"<%s was kicked because of mission file xfer failure>",
		"<%s was kicked for not having builtin mission %s>",
		"<%s was kicked for ingame joining an ended game>",
		"Warning\n\nThis pilot has played PXO games. If you continue and play a non-PXO game, your stats will not be updated",
		"Rank",
		"Missions Flown",
		"Flight Time",
		"Last Flown",
		"Fighter Kills",
		"Primary Shots Fired",
		"Primary Hit %",
		"Secondary Shots Fired",
		"Secondary Hit %",
		"Turn (Yaw) Axis",
		"Pitch Axis",
		"Bank Axis",
		"Absolute Throttle Axis",
		"Relative Throttle Axis",
		"Joystick/Mouse X Axis",
		"Joystick/Mouse Y Axis",
		"Joystick Z Axis",
		"Joystick rX Axis",
		"Joystick rY Axis",
		"Joystick rZ Axis",
		"Left Button",
		"Right Button",
		"Mid Button",
		"L/R",
		"U/B",
		"N",
		"Y",
		"Create",
		"Accept",
		"Options",
		"Medals",
		"Remove",
		"Select",
		"Clone",
		"Single",
		"Multi",
		"Convert",
		"<Server detected a hacked ships.tbl. Stats will not be saved>",
		"You are playing with a hacked ships.tbl, your stats will not be saved",
		"<Server detected a hacked weapons.tbl. Stats will not be saved>",
		"You are playing with a hacked weapons.tbl, your stats will not be saved",
		"<Not enough players were present at game start or end, stats will not be saved>",
		"<Server detected a non PXO validated mission. Stats will not be saved>",
		"This is not a PXO validated mission, your stats will not be saved",
		"You or the server you are playing on has a hacked ships.tbl. Your stats will not be updated on PXO",
		"You or the server you are playing on has a hacked weapons.tbl. Your stats will not be updated on PXO",
		"No/Invalid Image",
		"We have no recommendations for you.",
		"Technical Database",
		"Mission Simulator",
		"Cutscenes",
		"Credits",
		"Exit",
		"Single Missions",
		"Campaign Missions",
		"Commit",
		"Mission",
		"Filename",
		"Weapons",
		"Intelligence",
		"Ship Selection",
		"Weapon Loadout",
		"Continue",
		"Events",
		"Objectives",
		"Messages",
		"You need to have at least %d players per squad for Squad War",
		"Validating mission %s",
		"Validating squad war",
		"Please enter the match code",
		"SquadWar match does not check out. Please make sure the code you entered was correct and all players are valid members of their respective squads",
		"Storing SquadWar results",
		"<SquadWar results stored on PXO>",
		"<SquadWar results rejected by PXO>",
		"%s was killed by a beam from an unknown source",
		"%s was destroyed by a beam from %s",
		"No 3D acceleration",
		"Video",
		"Currently Selected Video Mode:",
		"A 3D accelerated video card must be selected in order to run Freespace.  Select your desired renderer from the above drop-down list.",
		"Detect Available Cards",
		"Options:",
		"Interlaced cutscenes",
		"Fast clear for cutscenes",
		"Fast Direct3D textures (lower visual quality)",
		"Freespace requires Glide or Direct3D hardware accleration. You will not be able to run Freespace without it",
		"Warning",
		"Up to Date",
		"Update Required",
		"Need to Install",
		"Windows NT has DirectX built in.  If you are running NT 4.0 you should have Service Pack 3 (SP3) or later installed.  For detailed information on NT Service Packs (including download links), go to:\n%s.\n\nDo you want to go to this link?",
		"Your version of DirectX is less than 5.0.  It is recommended that you install DirectX 5.0 on your system.\n\nDo you want to install DirectX 5.0?\n\n",
		"Your version of DirectX is up to date.\nFor detailed information on the latest version of DirectX (including download links), go to:\n%s.\n\nDo you want to go to this link?",
		"DirectX Version Info",
		"Your DirectX Version",
		"Your Version Status",
		"Freespace requires DirectX 3.0 (or greater).  DirectX 6.0 is required for Direct3D, Force Feedback, and Direct Sound 3D.",
		"Install/Update DirectX",
		"FreeSpace Launcher",
		"FreeSpace Demo Launcher",
		"The operating system is out of memory or resources.",
		"The .EXE file is invalid (non-Win32 .EXE or error in .EXE image).",
		"The operating system denied access to the specified file.",
		"The filename association is incomplete or invalid.\r\n(You need to have a default Internet browser installed)",
		"The DDE transaction could not be completed because other DDE transactions were being processed.",
		"The DDE transaction failed.",
		"The DDE transaction could not be completed because the request timed out.",
		"The specified dynamic-link library was not found.",
		"There was not enough memory to complete the operation.",
		"A sharing violation occurred.",
		"\r\nNo web browser found.  There isn't one installed or if \r\none is installed, it isn't set to be the default browser.\r\n\r\n",
		"Unknown error occurred.",
		"Warning!",
		"You must allow Setup to configure your default settings before playing Freespace for the first time.\n\nTo do this, press the 'Setup' button from the main menu and examine each tab.  Then, press the 'OK' button at the bottom.",
		"No Rendering Device Selected!",
		"You must allow Setup to configure your Video Card setting before playing Freespace.\n\nTo do this, press the 'Setup' button from the main menu and click on the Video Tab.  Then, press the 'Detect Available Cards' button and choose your video mode.  Finally, press the 'OK' button at the bottom.",
		"DirectX 3.0 or higher Required!",
		"You must install DirectX 3.0 or higher to run Freespace.\n\nTo do this, press the 'Setup' button from the main menu and click on the 'DirectX' tab and follow the direction on it.",
		"Error Launching FreeSpace",
		"Setup",
		"Error Loading README.TXT",
		"No uninstall information found.",
		"Are you sure you want to delete '%s' and all of its components?",
		"Confirm File Deletion",
		"Error Launching Uninstaller",
		"Welcome to FreeSpace!",
		"Since this is your first time running FreeSpace, you will now be automatically taken to the Setup window.  \n\nNOTE TO USER:\nIt is important that you view each section of the Setup window and configure it to your liking.  Press the Help button if you have questions about a particular section.  Once you are satisfied with your settings, select the OK button at the bottom of the Setup window to save them.",
		"Joystick",
		"<None>",
		"Current Joystick",
		"Enable Force Feedback",
		"Enable Directional Hit (Force Feedback)",
		"Calibrate",
		"Detect Available Joysticks",
		"FreeSpace CD not located.  Please insert FreeSpace CD #1 and select OK to continue.",
		"Misc",
		"Select Language",
		"Optional Command Line",
		"Couldn't Uninstall",
		"Network",
		"Internet Connection",
		"Connection Speed",
		"None",
		"Dialup Networking",
		"LAN/Direct Connection (and AOL)",
		"None Specified",
		"Slower than 56K Modem",
		"56K Modem",
		"Single Channel ISDN",
		"Dual Channel ISDN, Cable Modems",
		"T1, ADSL, T3, etc.",
		"Error reading CD.",
		"Speed",
		"Low",
		"Medium",
		"High",
		"Very High",
		"Default Detail Level:",
		"Properties",
		"CPU Type:",
		"CPU Speed:",
		"Total RAM:",
		"RAM Transfer Rate:",
		"VRAM Transfer Rate:",
		"3D Graphics Accelerator*:",
		"*Configured in the 'Video' tab.",
		"Detect",
		"Audio",
		"Aureal sound card detected, but you need updated drivers.  Download them from www.a3d.com",
		"This is non-Aureal-certified A3D!\nPlease upgrade your drivers at www.a3d.com",
		"No Sound",
		"Currently Selected Sound Card",
		"Detect Available Sound Cards",
		"Enable Launcher Sounds",
		"The Freespace Launcher needs to be updated to a newer version.\nHowever, the replacement executable or patch file could not be accessed.\n\nTherefore, the Launcher cannot be updated at this time.",
		"The Freespace Launcher needs to be updated to a newer version.\nHowever, the Update Launcher executable could not be found (or could not be accessed).\n\nTherefore, the Launcher cannot be updated at this time.",
		"The Freespace Launcher needs to be updated to a newer version.\nIt will now be shutdown, modified, and then restarted.\n\nThis may take several seconds...",
		"Launcher Update",
		"Error!",
		"Up to date",
		"Waiting for User",
		"Select Patch Download Site",
		"Patching Failed!!",
		"Connecting",
		"Downloading File",
		"URL redirected",
		"Download Cancelled",
		"Sorry, there is no message of the day.",
		"Unable to continue!!  Press Cancel.",
		"Unable to continue",
		"File not Found Error",
		"File Download HTTP error.  Status code: %d",
		"Downloading MOTD File",
		"Downloading Version Info File",
		"Downloading Sites File",
		"Unable to read sites from version.nfo",
		"Downloading Patch File",
		"Download %d bytes of %d  (%d%%)",
		"Couldn't parse Version file!",
		"The Freespace Auto-Update program could not find your current game Version in the system registry.\n\nThis should be corrected by starting up the game, exiting the game, and then running the Auto-Update program.",
		"Unable to Determine User's Version",
		"Press OK to download the new version of Freespace!!",
		"A new version of Freespace is available!!!  Press the OK button to download it.",
		"Determination: No Update Necessary",
		"Your Freespace version %d.%02d is currently up to date.",
		"Patching Error",
		"Processing %s",
		"File Complete!",
		"Searching for systems to update...",
		"Patching Failed!",
		"Patch Library not found.",
		"Patch Library not found.  Cannot Patch Freespace.",
		"Beginning Patching...",
		"Patching Complete!",
		"Error: URL could not be parsed",
		"Error: Site redirects with no new location",
		"Insufficient disk space to download file: ",
		"Error trying to download file",
		"Error trying to write file",
		"You must select a download site.",
		"Site Selection",
		"You must select a download site.",
		"Site Name",
		"URL",
		"Location",
		"The site info file could not be opened and parsed.",
		"Freespace Auto-Update",
		"Message of the Day:",
		"Your Version:",
		"Latest Version:",
		"Progress:",
		"Status:",
		"Patch Download Site Selection",
		"Select the site you wish to download from:",
		"Updating the Freespace Launcher...",
		"Please Wait",
		"ERROR: This program was executed outside of the Freespace Launcher!",
		"ERROR: Could not find file:  %s",
		"ERROR: Could not access file:  %s",
		"ERROR: Could not delete file:  %s",
		"ERROR: Could not rename file:  %s",
		"ERROR: The patch application function could not be obtained from the DLL.",
		"ERROR: The patch could not be completed successfully.",
		"Starting up the old Freespace Launcher...",
		"Starting up the new Freespace Launcher...",
		"ERROR: The Launcher could not be restarted.",
		"Freespace Launcher Update Error",
		"The launcher has not been updated.",
		"Unassigned",
		"All",
		"Coop",
		"Team",
		"Dogfight",
		"Refresh Missions",
		"Pilot Info",
		"Missions",
		"Campaigns",
		"1",
		"2",
		"Kick",
		"Host Options",
		"Create Game",
		"Players",
		"Lock",
		"has hacked tables/data",
		"One or more players has hacked data files. You cannot play a SquadWar match unless all clients have legal data",
		"One or more players has hacked data files. If you continue, stats will not be stored at the end of the mission",
		"One or more players has hacked data files",
		"<Team 1 had %d points>",
		"<Team 2 had %d points>",
		"<Match was a tie>",
		"<Team 1 (green) is the winner>",
		"<Team 2 (red) is the winner>",
		"Highest rank",
		"Team / wing-leader",
		"Any",
		"Host",
		"Skill level",
		"On",
		"Off",
		"Host modifies ships",
		"Respawn Limit",
		"AI Orders",
		"End Mission",
		"Time Limit",
		"Min",
		"Kill Limit",
		"Observers",
		"Voice Transmission",
		"Voice Quality",
		"Message Duration",
		"Voice Wait",
		"Refresh",
		"Join as",
		"Observer",
		"Game",
		"Join",
		"Status",
		"Server",
		"Players",
		"Ping",
		"Team 1",
		"Team 2",
		"Pilot",
		"Info",
		"Choose Team",
		"Web",
		"Ranking",
		"Find",
		"Motd",
		"Channel",
		"Private",
		"Games",
		"Squad",
		"Channels",
		"Open",
		"Closed",
		"Restricted",
		"Password Protected",
		"Allow Rank",
		"Above",
		"Below",
		"Start Game",
		"Title",
		"Game Type",
		"Enter Password",
		"Statistics",
		"Recommendations",
		"Play",
		"Loading",
		"Reset",
		"%s was killed by friendly fire from %s",
		"%s was destroyed by friendly beam fire from %s",
		"Targeting",
		"Ship",
		"Invert",
		"Undo",
		"Defaults",
		"Search",
		"Bind",
		"Clear",
		"Conflict",
		"All",
		"Selected",
		"Detail",
		"Control",
		"Config",
		"HUD",
		"Preset Detail Levels",
		"Custom",
		"Planets/backgrounds",
		"Target View Rendering",
		"Weapon Extras",
		"Model Detail",
		"Nebula Detail",
		"3D Hardware Textures",
		"Particles",
		"Impact Effects",
		"Shield Hit Effects",
		"Stars",
		"Lighting",
		"Briefing Voice",
		"Volume",
		"Effects",
		"Music",
		"Voice",
		"Mouse",
		"Sensitivity",
		"Brightness",
		"Joystick",
		"Deadzone",
		"TCP",
		"IPX",
		"IP Address",
		"add",
		"rem.",
		"PXO",
		"Login",
		"Password",
		"Squadron",
		"Broadcast Locally",
		"General",
		"Mic test",
		"Mute",
		"Object Update",
		"Lan",
		"Pilot / Squad Images",
		"Yes",
		"No",
		"Transfer Missions",
		"/multidata",
		"/missions",
		"Flush Cache",
		"Never",
		"Before Game",
		"You have selected IPX for multiplayer Freespace, but the IPX protocol was not detected on your machine.",
		"Restart",
		"Campaign",
		"Replay",
		"Incoming Transmission",
		"complete",
		"Create",
		"Select",
		"Mission",
		"Misc",
		"Game",
		"Clear",
		"Clear",
		"Config",
		"Exit",
		"Exit",
		"Exit",
		"Exit",
		"Exit",
		"You have killed yourself with a shockwave from your own weapon",
		"You have killed yourself with your own missiles",
		"name",
		"class",
		"status",
		"primary",
		"secondary",
		"Blast",
		"Engine Wash",
		"Evaded",
		"Collision",
		"Replay previous mission",
		"You cannot join a game in progress unless it is a dogfight mission.",
		"Barracks",
		"Pilot Stats",
		"Choose Pilot",
		"Complete",
		"Incomplete",
		"Failed",
		"Mission Paused",
		"Press ESC to return to the game",
		"Skip Training",
		"Don't show me this again",
		"&Next",
		"You cannot change your squadron in Single Player mode.",
		"Please configure your system in the Launcher before running FS.\n\n The Launcher will now be started!",
		"Attention!",
		"Warning, Freespace requires Glide or Direct3D hardware accleration. You will not be able to run Freespace without it.",
		"Warning",
		"The Launcher could not be restarted.",
		"Error",
		"Previous Mission",
		"Popup",
		"Save",
		"Amber",
		"Blue",
		"Green",
		"Brightness",
		"warning flash",
		"comm menu",
		"support gauge",
		"lag gauge",
		"auto",
		"speed",
		"target",
		"Exit",
		"Decline",
		"Please insert CD %d",
		"more",
		"You have failed this mission five times.",
		"If you like, you may advance to the next mission.",
		"You have failed this mission five times.  If you like, you may advance to the next mission.",
		"Do Not Skip This Mission",
		"Advance To The Next Mission",
		"Don't Show Me This Again",
		"Self destructed",
		"Exit Loop",
		"SquadWar results invalidated",
		"\r\nUnable to locate Fred Help file: \\data\\freddocs\\index.html\r\n",
		"DirectDraw could not be initialized on your system.  DirectDraw v6.0 or higher\nis required in order to play FreeSpace.",
		"Attention!",
		"Need to run FreeSpace first to set version info.",
		"Original '%s' contents do not match, update aborted.  Re-installing may be necessary.  \n\n",
		"If problem persists, please contact Volition Support, support@pxo.net.",
		"Detect Direct3D",
		"Detect Glide",
		"Turret",
		" subsystem cargo revealed: ",
		"Exit Loop\n\n\n\nAre you sure you want to leave the mission loop?",
		"<No Mission Loop Description Available>",
		"\n\n\nDo you want to play the optional mission?",
		"OK",
		"Nothing",
		"%s was killed by engine wash from %s",
		"There is a limit of %d ships in the mission at once.  Please be sure that you do not have more than %d ships present in the mission at the same time.",
		"An error occured while patching the Launcher, 'FreeSpace2.exe'.\nThe remaining files were updated successfully, but your Launcher is still out-of-date.\nWe recommend that you manually download the latest Launcher from our website:\n\n",
		"\n\nDo you want to want to visit the site now?",
		"Error Patching the Launcher",
		"Vertex fog or Table fog\r\n",
		"Joining netgame",
		"<kicking %s ...>",
		"Force WFOG (not recommended)",
		"Disable Direct3D Zbuffer bias",
		"Briefing",
		"Join",
		"Join",
		"Launch",
		"Close",
		"Skill Level",
		"Alt",
		"Shift",
		"R",
		"G",
		"B",
		"I",
		"Cancel",
		"Clear",
		"Reset",
		"Help",
		"Options",
		"Accept",
		"sec",
		"sec",
		"&Go back",
		"&Continue",
		"Mission score",
		"Score",
		"Voice",
		"Sensitivity",
		"Voice Transmission",
		"Voice Quality",
		"Name",
		"Rank",
		"Kills",
		"Assists",
		"Friendly kills",
		"Missions flown",
		"Flight time",
		"Last flown",
		"Primary shots fired",
		"Primary shots hit",
		"Primary hit %",
		"Secondary shots fired",
		"Secondary shots hit",
		"Secondary hit %",
		"Primary friendly hits",
		"Primary friendly hit %",
		"Secondary friendly hits",
		"Secondary friendly hit %",
		"Select",
		"All",
		"Select",
		"Weapons",
		"Detect 32 bit",
		"Detect hi-res",
		"PXO Account",
		"Login",
		"Password",
		"Skip version check in PXO",
		"PXO Banners",
		"Misc",
		"Force local port",
		"German",
		"English",
		"NEW USER TIP\n\n%s",
		"Flak turret",
		"Beam turret",
		"Laser turret",
		"Missile lnchr"		
	},

	// German
	{
		"Cheat: Spielerschiff = %s",
		"Cheat: Zielobjekt = %s",
		"Cheat: Soundtrack = %s",
		"FEHLER: Fehler beim Spielen der Musik.",
		"Bildverzögerung erhöht auf %i Millisekunden / Frame.",
		"Bildverzögerung gesenkt auf %i Millisekunden / Frame.",
		"Cheat: Täuschkörper-Abschussrate = %s",
		"AKTIVIERT",
		"DEAKTIVIERT",
		"Cheat: Rumpfzustand = %7.3f%\n",
		"Cheat: Sie sind %s",
		"nun UNBESIEGBAR!",
		"wieder besiegbar...",
		"Cheat: Das Zielobjekt des Spielers [%s] ist %s.",
		"Debuginformationen über Objekt #%d ausdrucken...",
		"Cheat: Unendliche Waffen/Energie für ALLE SCHIFFE!",
		"Cheat: Unendliche Waffen/Energie!",
		"Cheat: Waffen/Energie-Cheat deaktiviert!",
		"Cheat: Sekundärwaffe festgelegt auf %s",
		"Cheat: Primärwaffe festgelegt auf %s",
		"Cheat: Ereignis-Musik ausgeschaltet",
		"Cheat: Ereignis-Musik ausgeschaltet",
		"Cheat: Detailstufe festgelegt auf %+d\n",
		"Cheat: Framerate-Test gestartet",
		"Cheat: Zielspezies geändert auf %s",
		"Cheat: Fähigkeitsstufe geändert auf %s.",
		"Kein Zielobjekt hinzuzufügen/zu entfernen von Set %d.",
		"Zielobjekt %s wurde zum Set %d (F%d) hinzugefügt.",
		"&Ja, Beenden",
		"Ja, &Neustart",
		"Wollen Sie den Einsatz wirklich beenden?",
		"Cheat: Cheatmodus aktiviert.",
		"Cheat: Alle Filme sind nun im Technikraum verfügbar.",
		"Dieses Schiff hat keine Sekundärwaffen.",
		"Sekundärwaffensystem im Einzelfeuermodus",
		"Sekundärwaffensystem im Doppelfeuermodus ",
		"Steuerung bewegt das Schiff",
		"Steuerung bewegt Aussenkamera",
		"Radarreichweite = %s",
		"*** Kollisionsgefahr - Sprungantrieb nicht aktiviert ***",
		"*** Triebwerksdefekt - Sprungantrieb kann nicht aktiviert werden ***",
		"&Wiederholen",
		"&Ignorieren",
		"&Spiel beenden",
		"Achtung!\nKonnte Piloten nicht speichern. Möglicherweise ist Ihre Festplatte voll. In diesem Fall drücken Sie bitte ALT-TAB, um Platz freizumachen.\n",
		"'",
		"s",
		"&Nein",
		"&Ja",
		"Achtung!\nEin Pilot mit diesem Namen existiert bereits.\nSoll er überschrieben werden?",
		"*Abschuss-Statistik",
		"Schüsse mit Primärwaffen:",
		"davon Treffer:   ",
		"Treffer auf Verbündete:   ",
		"Trefferquote:   ",
		"%.1f%%",
		"Trefferquote auf Verbündete:   ",
		"Schüsse mit Sekundärwaffen:",
		"davon Treffer:   ",
		"Treffer auf Verbündete:   ",
		"Trefferquote:   ",
		"Trefferquote auf Verbündete:   ",
		"Abschüsse insgesamt:",
		"Unterstützung bei:",
		"*Abschüsse nach Schiffsklassen",
		"Achtung!\n\nWollen Sie diesen Piloten wirklich löschen?",
		"Sie müssen zunächst einen Piloten für den Solospieler-Modus erstellen.",
		"Sie müssen zunächst einen Piloten für den Mehrspieler-Modus erstellen.",
		"Mehrspieler",
		"Solospieler",
		"Dadurch wird der Pilot '%s' überschrieben. Wollen Sie das wirklich?",
		"%d/%d",
		"mdls",
		"pause",
		"wpns",
		"god view",
		"plyr view",
		"prev view",
		"zoom in",
		"zoom out",
		"ESC zum beenden",
		"*** Sprungantrieb defekt ***",
		"*** Das Schiff muss zumindest %.1f km/s erreichen können, um den Sprungantrieb zu aktivieren ***",
		"Passagiere:\n   %s",
		"Fracht: %s",
		"Gescannt",
		"Fracht: <unbekannt>",
		"Nicht gescannt",
		"Fracht wird gescannt...",
		"Wird gescannt...",
		"Rakete",
		"Laserschuss",
		"%s stirbt durch die Schockwelle einer Bombe",
		"%s stirbtin der Schockwelle der Explosion von %s",
		"%s wurde von %s abgeschossen und ist tot",
		"%s stirbt bei der Explosion von %s",
		"%s stirbt bei der Kollision mit %s",
		"%s stirbt bei der Kollision mit Trümmern",
		"%s stirbt bei der Kollision mit Asteroiden",
		"%s stirbt aus ungeklärter Ursache",
		"Oops! Selbstmord!",
		"Blick nach oben",
		"Blick nach hinten",
		"Blick nach links",
		"Blick nach rechts",
		"Einsatz neu starten",
		"Zum Flugdeck",
		"In den Bereitschaftsraum ",
		"Beobachtermodus",
		"Wiederbeleben",
		"Achtung!\nDie aktuellen Feldzugdaten werden gelöscht.\nSie müssen ganz von vorne beim\nersten Einsatz beginnen.",
		"Der Demo-Feldzug ist vorbei. Wollen Sie ihn neu starten?",
		"Der Feldzug ist vorbei. Wenn Sie ihn noch einmal spielen wollen, müssen Sie ihn entweder im Planungsraum neu starten oder einen neuen Piloten anlegen.",
		"Achtung!\nDie aktuellen Daten des Feldzuges '%s' werden gelöscht.\nSie müssen ganz von vorne beim\nersten Einsatz beginnen.",
		"Einsatzdaten",
		"Abschüsse gesamt",
		"Schüsse mit Primärwaffen",
		"    davon Treffer",
		"    Treffer auf Verbündete",
		"    Trefferquote",
		"    Trefferquote auf Verbündete",
		"Schüsse mit Sekundärwaffen",
		"    davon Treffer",
		"    Treffer auf Verbündete",
		"    Trefferquote",
		"    Trefferquote auf Verbündete",
		"Unterstützung bei",
		"Gestorben",
		"Abschuss-Statistik",
		", ",
		"keine Zuweisung",
		" - ",
		"Seite %d von %d",
		"Standardtasten",
		"Funktionstasten",
		"F1",
		"Kontextbezogene Hilfe",
		"F2",
		"Optionen (überall im Spiel verfügbar)",
		"F3",
		"Tastenbelegung konfigurieren",
		"F4",
		"HUD-Meldungen zurückblättern",
		"F5..F12",
		"Frei belegbar",
		"Shift-Esc",
		"FreeSpace direkt verlassen",
		"Bewegungstasten",
		"Zielen: Grundfunktionen",
		"Zielen: Erweiterte Funktionen",
		"Ziel dieser Taste anwählen",
		"Shift-F5..F12",
		"Taste neu belegen (Ziel hinzufügen/entfernen)",
		"Alt-Shift-F5..F12",
		"Tastenbelegung löschen",
		"Kommunikationstasten",
		"Zielen dieser Tasten einen Befehl erteilen",
		"Waffentasten",
		"Energiemanagement-Tasten",
		"Sonstige Funktionen",
		"ESC",
		"Einsatz abbrechen (Sicherheitsabfrage)",
		"Pause",
		"Spielunterbrechung",
		"Druck",
		"Screenshot abspeichern",
		"Perspektive-Tasten",
		"Mehrspielerfunktionen",
		"Nachricht absenden (antippen für Text, halten für Sprachübertragung)",
		"FEHLER: Fehler beim Laden des Einsatzes.",
		"FreeSpace Demo",
		"FreeSpace",
		"Diese Version von FreeSpace wurde kompiliert für\n\n",
		"\n\nDrücken Sie OK, um fortzufahren.\n",
		"WEITERGABE UNTERSAGT!",
		"Diese Version von FreeSpace wurde kompiliert für\n\n",
		"Drücken Sie eine beliebige Taste.",
		"Ihrem Raumjäger geht das Getriebeöl aus. Bitte überprüfen \nSie den Ölstand und füllen Sie gegebenenfalls nach.",
		"Freespace ist SEHR müde. \nEs schaltet jetzt ab und ruht sich etwas aus.",
		"Verbleibende Einsatzzeit: %d Sekunden",
		"Bytes empfangen: %d",
		"Bytes gesendet: %d",
		"Aussenansicht des Spielerschiffs.",
		"Innenansicht des Spielerschiffs.",
		"Sprungknoten",
		"Ansicht von %s%s\n",
		"von ",
		"Beobachtermodus\n",
		"Eigene Sicht\n",
		"Schnellstart",
		"Zurück zum Flugdeck",
		"Zurück zum Bereitschaftsraum",
		"Sie sind gestorben",
		"FreeSpace hat entdeckt, dass Sie nur über %d MB hauptspeicher verfügen.\n\nFreeSpace benötigt aber mindestens 32 MB Hauptspeicher. Wenn Sie sicher sind, dass Sie mehr als %d MB RAM eingebaut haben, vergewissern Sie sich bitte, dass SmartDrive nicht aktiv ist (SMARTDRV.EXE). Aller Hauptspeicher, der SmartDrive zugewiesen ist, kann von anderen Programmen nicht mehr genutzt werden. \n\nWählen Sie 'OK', um mit weniger als der empfohlenen Mindestmenge an Hauptspeicher zu spielen. \n",
		"Nicht genug Hauptspeicher.",
		" FreeSpace hat entdeckt, dass Sie nur über %d MB hauptspeicher verfügen.\n\nFreeSpace benötigt aber mindestens 32 MB Hauptspeicher. Wenn Sie sicher sind, dass Sie mehr als %d MB RAM eingebaut haben, vergewissern Sie sich bitte, dass SmartDrive nicht aktiv ist (SMARTDRV.EXE). Aller Hauptspeicher, der SmartDrive zugewiesen ist, kann von anderen Programmen nicht mehr genutzt werden.\n",
		"FreeSpace benötigt virtuellen Speicher.\r\n",
		"Kein virtueller Speicher",
		"Nicht genug Speicher verfügbar, um FreeSpace zu starten.\r\nSchliessen Sie einige Anwendungen, und versuchen Sie es erneut.\r\n",
		"Nicht genug Speicher",
		"Das gibt es nur in der Vollversion",
		"%d:",
		"Freespace-CD nicht gefunden\n\nSie müssen eine Freespace-CD einlegen, um weiterzumachen",
		"Filmsequenz nicht gefunden\n\nBitte legen Sie die\nFreespace-CD #%d nein.",
		"Filmsequenz %s konnte nicht abgespielt werden.",
		"Konflikt!",
		"Abgebrochen",
		"Diese Taste kann nicht belegt werden.",
		"?",
		"Einstellung ist in Konflikt mit ",
		"Mehr...",
		"-",
		", ",
		"Fehler beim Abspielen der Musik",
		"Stück %s [%s]",
		"x%.1f",
		"x%.0f",
		"Nachricht",
		"Status",
		"%d%%",
		"Rumpfzustand",
		" <->",
		"tot",
		"Abschüsse",
		"Versorgung",
		"abgebrochen!",
		"abgeschlossen",
		"Reparatur...",
		"lädt nach...",
		"blockiert",
		"kommt",
		"beschäftigt",
		"kommt",
		"Sprungantrieb",
		"aktiviert",
		"Empfange neue ",
		"Anweisungen...",
		"Primärziel",
		"Sekundärziel",
		"Bonusziel",
		"nicht erreicht (%d/%d)",
		"erreicht (%d/%d)",
		"nicht erreicht",
		"[Sprachausgabe verweigert]",
		"[Sprachaufnahme]",
		"[Sprachausgabe]",
		"2.000 m",
		"10.000 m",
		"unendlich",
		"Vorhalt-Markierung ",
		"Ausrichtung des Ziels",
		"Nähester Angreifer",
		"Zielrichtung",
		"Einsatzzeit",
		"Visier",
		"Schub",
		"Radar",
		"Zielmonitor",
		"Fadenkreuz",
		"Zieldaten",
		"Schildanzeige des Zieles",
		"Eigene Schildanzeige",
		"Energiezuteilung",
		"Auto-Zielerfassung",
		"Auto-Tempoanpassung",
		"Waffen",
		"Geleitschutzliste",
		"Anweisungen",
		"Angriffswarnanzeige",
		"Nachbrenner-Energie",
		"Waffenenergie",
		"Waffenkopplung",
		"Rumpf/Schildanzeige des Zieles",
		"Randanzeige",
		"Kommunikationsbildschirm",
		"Schadensanzeige",
		"Nachrichten",
		"Ausrichtung anfliegender Raketen",
		"Täuschkörper",
		"Einsatzziel-Meldung",
		"Geschwader-Status",
		"Zieldistanz Randanzeige",
		"Anzahl Abschüsse",
		"Zahl Angreifer auf Ziel",
		"L",
		"Geleitschutzliste",
		"Geleitschutzmonitor aktiviert",
		"Geleitschutzmonitor deaktiviert",
		"*** Es können nicht mehr als %d Schiffe gleichzeitig auf der Geleitschutzliste angezeigt werden ***",
		"Einsatzdauer",
		"",
		"",
		"0",
		"Schiff",
		"Staffel",
		"Alle Jäger",
		"Verstärkung rufen",
		"Versorgungsschiff",
		"Versorgung abbrechen",
		"Ziel zerstören",
		"Ziel lahmlegen",
		"Ziel entwaffnen",
		"Subsystem zerstören",
		"Ziel beschützen",
		"Ziel ignorieren",
		"Bei mir formieren",
		"Gebt mir Deckung!",
		"Feinde angreifen",
		"Ziel kapern",
		"Versorgungsschiff rufen",
		"Versorgung abbrechen",
		"System verlassen",
		"[Bild hoch]",
		"[Bild runter]",
		"Keine Befehle verfügbar",
		"*** Kommunikation verweigert ***",
		"Empfänger",
		"Schiff",
		"Geschwader",
		"Schiff/Geschwader",
		"(*)",
		"Befehl",
		"*** Kein Zielobjekt ausgewählt ***",
		"Subsystem %s erfasst.",
		"Subsystem-Erfassung deaktiviert",
		"Zielerfassung deaktiviert",
		"%d%%",
		"TK",
		"Waffen",
		"<keine>",
		"*** Beschädungen an den Sensoren verhindern Zielerfassung ***",
		"*** Beschädigungen am Funksystem verhindert Funkverkehr ***",
		"*** Kein Versorgungsschiff in der Nähe. Fordern Sie über das Kommunikationsmenü eins an. ***",
		"Kommunikation",
		"Funk",
		"Navigation",
		"Nav",
		"keine Befehle",
		"Dauer: ",
		"kommt: %s",
		"d: %.0f",
		"%d%%",
		"LAHMGELEGT",
		"AUSGESCHALTET",
		"aus",
		"Ok",
		"def",
		"krt",
		"Trümmer",
		"unbekannt",
		"E: %.0f%s",
		"G: %.0f%s",
		"Staffeln",
		"Freespace beenden",
		"Pilotenquartier - Freespace-Piloten verwalten",
		"Bereitschaftsraum - Feldzug starten oder fortsetzen",
		"Technikraum - Über Schiffe und Waffen informieren",
		"Optionen - Freespace konfigurieren",
		"Planungsraum - Feldzug auswählen und verwalten",
		"Mehrspieler - Mehrspielerspiel starten oder beitreten",
		"Sie haben Ihre Internetverbindung nicht ausgewählt. Bitte starten Sie den Launcher, klicken Sie auf 'Setup' und geben Sie unter 'Netzwerk' Ihre Verbindungsart ein.",
		"WinSock ist nicht installiert. Ohne TCP/IP und WinSock ist kein Mehrspielerspiel möglich.",
		"Sie haben TCP/IP als Protokoll ausgewählt, aber dieses Protokoll ist auf Ihrer Maschine nicht installiert.",
		"Sie haben 'Netzwerk-Einwahl' als Internetverbindung angegeben, sind aber nicht bei ihrem Internet-Service-Provider eingewählt. Bitte holen Sie das jetzt nach, oder wählen Sie im Launcher 'LAN' als Verbindungstyp.",
		"Sie haben LAN als Netzwerkverbindung ausgewählt. Sie scheinen jedoch gleichzeitig bei einem Provider eingewählt zu sein. Bitte trennen Sie zunächst diese Verbindung, oder wählen Sie 'Netzwerk-Einwahl'.",
		"Das Spiel beenden?",
		"Der Planungsraum steht nur im Solospielermodus zur Verfügung.",
		"Ungültige Mehrspieler-Spielerdatei",
		"'Einsatz laden' ist bei Mehrspieler-Piloten nicht möglich",
		"'Schnellstart' ist bei Mehrspieler-Piloten nicht möglich ",
		"Schwierigkeitsgrad = %s.",
		"Drücken Sie F1 für Hilfe",
		"Sie können die Fähigkeitsstufe nicht mitten in einem Einsatz verändern.",
		" Sie können die Fähigkeitsstufe für Mehrspielerrunden hier nicht ändern. Die Fähigkeitsstufe wird von Spielleiter auf seinem Optionsbildschirm festgelegt.",
		"Das Spiel beenden?",
		"Als Beobachter können Sie das HUD nicht konfigurieren!",
		"Solospieler-Modus",
		"Mehrspieler-Modus",
		"FEHLER: Kein Pilot ausgewählt!",
		"Es können keine weiteren Piloten angelegt werden.",
		"FEHLER: Pilotendatei konnte nicht erstellt werden!",
		"Bitte geben Sie einen Pilotennamen ein",
		"Achtung!\n\nWollen Sie diesen Piloten wirklich löschen?",
		"Wollen Sie diesen Piloten wirklich löschen?",
		"FreeSpace, Copyright %c 1999, Volition, Inc.",
		"Copyright (C) 1999, Volition, Inc. Alle Rechte vorbehalten",
		"Ungültige IP-Adresse!",
		"&Abbruch",
		"IP-Adresse wird überprüft...",
		"Maximale Anzahl an IP-Adressen erreicht!",
		"Aufgezeichnete Sprache kann nicht abgespielt werden. Bitte überprüfen Sie Ihre Hardware.",
		"Während eines Mehrspieler-Spiels kann das Mikrophon nicht getestet werden.",
		"DirectSoundCapture konnte nicht gestartet werden. Bitte überprüfen Sie, ob Ihre Soundkarte auf Vollduplex eingestellt ist und ihre Treiber DirectSoundCapture unterstützen.",
		"FEHLER: Datenüberlauf",
		"Abschnitt %d von %d",
		"Schauen Sie sich nochmal die Einsatzziele an.",
		"Primäres",
		"Sekundäres",
		"Bonus",
		"*Primäre Einsatzziele",
		"*Sekundäre Einsatzziele",
		"*Bonusziele",
		"Verbündete Schiffe",
		"Feindliche Schiffe",
		"Zerstört",
		" Durch: ",
		"eingetroffen",
		"eingetroffen (%d. Welle)",
		"Abgeflogen",
		"Angedockt an ",
		"Subsystem ",
		" zerstört",
		"Abgedockt von ",
		"Lahmlegen von",
		"Entwaffnen von",
		" fordert Versorgungsschiff an",
		" bricht Nachladevorgang ab",
		"Als Verstärkung herbeigerufen",
		"Fracht gescannt: ",
		"%s Einsatzziel ",
		"erreicht.",
		"fehlgeschlagen.",
		"Anweisungen",
		"Training fehlgeschlagen",
		"Taste &zuweisen",
		"&Einsatz abbrechen",
		"Achtung!\nSie haben der Funktion '%s' keine Taste zugeordnet. Bitte tun Sie das, bevor Sie mit ihrer Ausbildung fortfahren.\n",
		"<%s wurde rausgeworfen>",
		"Zurück",
		"Training überspringen\n\nWollen Sie diesen Trainingseinsatz wirklich überspringen?\n\n(Hinweis: Sie können ihn später trotzdem über den Einsatzsimulator im Technikraum aufrufen)",
		"Keine Daten für den Einsatz %s vorhanden.",
		"Asteroid",
		"Sprungknoten",
		"unbekannt",
		"-Klasse",
		"Orden",
		"Dienstgrad",
		"Abzeichen",
		"(O)",
		"Ihre Karriere ist beendet, Verräter! Sie werden nicht mehr gebraucht!",
		"Pfuscher können wir nicht gebrauchen. Spielen Sie den Einsatz noch mal, aber ohne Cheats, um weiterzukommen!",
		"Da Sie in diesem Einsatz versagt haben, können wir Sie nicht zum nächsten Einsatz zulassen. Was wollen Sie statt dessen machen?",
		"Zurück zur Abschlussbesprechung",
		"Zum Flugdeck",
		"Einsatz wiederholen",
		"%d von %d",
		"Einsatzzeit",
		"Einsatz-Abschüsse nach Schiffstyp",
		"Gesamtabschüsse nach Schiffstyp",
		"(Keine)",
		"(Keine)",
		"&Wiederholen",
		"Wenn Sie sich entscheiden, diesen Einsatz zu wiederholen, müssen Sie ihn komplett neu schaffen, bevor Sie weiterspielen können.\n\nAusserdem werden dann die bisherigen Statistiken verworfen.",
		"Wir haben dem nichts hinzuzufügen.",
		"&Ja",
		"&Nein, später erneut versuchen",
		"Akzeptieren Sie diesen Ausgang Ihres Einsatzes? ",
		"Da Sie bei diesem Einsatz versagt haben, müssen Sie ihn noch einmal spielen, wenn Sie den Feldzug fortsetzen möchten.\n\nWollen Sie nun zum Flugdeck zurück?",
		"Keine Daten für Abschlussbesprechung vorhanden\n\nMission: %s",
		"Mehr",
		"Mindestens ein Schiff muss eingeteilt sein, bevor Sie dessen Waffenbestückung ändern können.",
		"Spielerschiff ist nicht mit Waffen ausgerüstet.",
		"Spieler %s muss einen Platz im Geschwader auswählen.",
		"",
		"Abschnitt %d von %d",
		"*** Sie sind zu dicht an einem Planeten ***",
		"Sprungvorgang wurde abgebrochen.",
		"2 km",
		"10 km",
		"Anfänger",
		"Flugschüler",
		"Flieger",
		"Kampfpilot",
		"As",
		"Angriff auf ",
		"Andocken an ",
		"Nav-Punkte",
		"Zerstören von ",
		"Geleitet ",
		"Abdocken von ",
		"Bewacht ",
		"Lahmlegen von ",
		"Entwaffnet ",
		"Weicht aus ",
		"Nachladen ",
		"*** Keine Täuschkörper mehr vorhanden ***",
		"%s gezündet!",
		"*** Entfernung zu gross zur Zielerfassung ***",
		"*** %s: Zielerfassung noch nicht abgeschlossen ***",
		"*** %s: Waffensystem beschädigt, Abschuss unmöglich ***",
		"*** Sie haben keine Primärwaffe ***",
		"*** Sie haben nur eine einzige Primärwaffe: %s ***",
		"*** Sie haben keine Sekundärwaffen ***",
		"*** Sie haben nur eine einzige Sekundärwaffe: %s ***",
		"-Geschwader",
		"keine Befehle",
		"atk %s %s",
		"<Unbekannt>",
		"Subraumantrieb aktiviert...",
		"ACHTUNG: Subsystem '%s' Ihres Schiffes wurde zerstört.",
		"Conflict: FreeSpace - Darkness Rising, Copyright %c 1998, Volition, Inc.",
		"Descent: FreeSpace - Darkness Rising, Copyright %c 1998, Volition, Inc.",
		"Conflict: FreeSpace - The Great War, Copyright %c 1998, Volition, Inc.",
		" &OK",
		"&Abbruch",
		"&Ja",
		"&Nein",
		"Nächstes Schiff",
		"Vorheriges Schiff",
		"Nächstes feindliches Schiff",
		"Vorheriges feindliches Schiff",
		"Automatische Zielerfassung",
		"Nächstes verbündetes Schiff",
		"Vorheriges verbündetes Schiff",
		"Schiff im Fadenkreuz",
		"Nächster Angreifer des aktuellen Zielobjekts",
		"Schiff desjenigen, der zuletzt gefunkt hat",
		"Automatische Zielerfassung deaktivieren",
		"Subsystem im Fadenkreuz",
		"Nächstes Subsystem",
		"Vorheriges Subsystem",
		"Zielerfassung von Subsystemen deaktivieren",
		"Automatische Geschwindigkeitsanpassung",
		"Automatische Geschwindigkeitsanpassung an/aus",
		"Primärwaffe abfeuern",
		"Sekundärwaffen abfeuern",
		"Nächste Primärwaffe",
		"Vorherige Primärwaffe",
		"Raketenlafette wechseln",
		"Sekundär: Einzel-/Doppelfeuermodus",
		"Täuschkörper einsetzen",
		"Geschwindigkeit erhöhen",
		"Geschwindigkeit reduzieren",
		"Rollen gegen den Uhrzeigersinn",
		"Rollen im Uhrzeigersinn",
		"Nach unten neigen",
		"Nach oben neigen",
		"Nach links drehen",
		"Nach rechts drehen",
		"Schiff anhalten",
		"Auf maximale Geschwindigkeit gehen",
		"Auf 1/3 Geschwindigkeit gehen ",
		"Auf 2/3 Geschwindigkeit gehen ",
		"Geschwindigkeit um 5 Prozent erhöhen",
		"Geschwindigkeit um 5 Prozent reduzieren",
		"(Befehl) Zielobjekt angreifen",
		"(Befehl) Zielobjekt entwaffnen",
		"(Befehl) Zielobjekt lahmlegen",
		"(Befehl) Subsystem angreifen",
		"(Befehl) Zielobjekt erobern",
		"(Befehl) Feinde angreifen",
		"(Befehl) Geschwader formieren",
		"(Befehl) Zielobjekt ignorieren",
		"(Befehl) Zielobjekt beschützen",
		"(Befehl) Gebt mir Deckung!",
		"(Befehl) System verlassen",
		"(Befehl) Versorgungsschiff rufen",
		"Nächster Angreifer",
		"Sicht von hinten (Verfolgerperspektive)",
		"Sicht von aussen",
		"Externe Kamera sperren/lösen",
		"Freie Kamera",
		"Sicht von aktuellem Zielobjekt",
		"Sichtweite erhöhen",
		"Sichtweite reduzieren",
		"Sicht zentrieren",
		"Blick nach oben",
		"Blick nach unten",
		"Blick nach links",
		"Blick nach rechts",
		"Radarreichweite einstellen",
		"Kommunikationsmenü aufrufen",
		"Einsatzziele anzeigen",
		"Sprungantrieb aktivieren (Einsatz beenden)",
		"Ziel des derzeitigen Zieles erfassen",
		"Nachbrenner",
		"Mehr Energie auf Waffensysteme umleiten",
		"Weniger Energie auf Waffensysteme umleiten",
		"Mehr Energie auf Schilde umleiten",
		"Weniger Energie auf Schilde umleiten",
		"Mehr Energie auf Triebwerke umleiten",
		"Weniger Energie auf Triebwerke umleiten",
		"Gleichmässige Energieverteilung",
		"Schildausgleich",
		"Frontschild verstärken",
		"Heckschild verstärken",
		"Linken Schild verstärken",
		"Rechten Schild verstärken",
		"Energie vom Laser auf die Schilde umleiten ",
		"Energie von den Schilden zum Laser umleiten ",
		"Schadensbericht anzeigen",
		"Drehung bei Druck",
		"Navigationskarte anzeigen",
		"Ziel überwachen/entfernen",
		"Geleitschutzliste löschen",
		"Nächstes Schiff der Geleitschutzliste",
		"Nächstes Versorgungsschiff",
		"Nächstes Schiff mit ungescannter Fracht",
		"Vorheriges Schiff mit ungescannter Fracht",
		"Neuestes Schiff im Kampfgebiet",
		"Nächster funktionstüchtiger Geschützturm",
		"Vorheriger funktionstüchtiger Geschützturm",
		"Nächster feindlicher Bomber/Bombe",
		"Vorheriger feindlicher Bomber/Bombe",
		"(Mehrspieler) Nachricht an alle",
		"(Mehrspieler) Nachricht an Verbündete",
		"(Mehrspieler) Nachricht an Feinde",
		"(Mehrspieler) Nachricht an Ziel",
		"(Mehrspieler) Beobachter: Objekt vergrössern",
		"Zeitraffer erhöhen (1x=>2x=>4x)",
		"Zeitraffer reduzieren (1x<=2x<=4x)",
		"Helleres HUD ein/aus",
		"(Mehrspieler) Netzwerk-Verzögerung ein-/ausblenden",
		"(Mehrspieler) Selbstzerstörung",
		"",
		"",
		"",
		"",
		"",
		"",
		"Alphakanal-Texturen",
		"Fehlende Optionen",
		"16-bpp RGB-Texturen",
		"Ihre Grafikkarte erfüllt die folgenden Voraussetzungen nicht:\r\n\r\n",
		"'Texture blending'-Modus = Modulate\r\n",
		"'Source blending'-Modus = SRCALPHA oder BOTHSRCALPHA\r\n",
		"'Destination blending'-Modus = INVSRCALPHA oder BOTHINVSRCALPHA\r\n",
		"Es muss mindestens 1 MB Grafikspeicher zur Verfügung stehen.",
		"> 1 sek",
		"%d ms",
		"A: ",
		"U: ",
		"Sprungpunkt %d",
		"Der %s kann keine %s tragen",
		"Unbekannter Befehl",
		"** CTCP Nachricht von %s (%s)",
		"** %s ist dem Kanal %s zugetreten",
		"*** %s hat %s aus dem Kanal %s (%s) rausgeworfen",
		"*** %s spielt von nun an unter dem Namen %s ",
		"**FEHLER: %s ist nicht online!",
		"Ihr Spielername enthält nicht erlaubte Zeichen!",
		"&Abbruch",
		"Verbindung zum Server abgebrochen. Simulation wird gestoppt, bis neuer Kontakt hergestellt ist. Klicken Sie auf 'Abbruch', um das Spiel zu beenden.",
		"Der Feldzug ist abgeschlossen. Vielen Dank fürs Spielen.",
		"Feldzug-Arsenal Schiffe/Waffen\n",
		"&Abbruch",
		"Bitte warten...\nVerbindungen mit den Spielern werden getrennt...",
		"Achtung! - Dadurch werden alle Spieler rausgeworfen!",
		"Sind Sie sicher, dass Sie das Spiel beenden wollen?",
		"<Teamcaptains haben das Spiel verlassen>",
		"<Der Server hat das Spiel beendet>",
		"FEHLER!\n\nSie wurden vom Spielleiter rausgeworfen.",
		"Der Server hat das Spiel verlassen",
		"FEHLER!\n\nIhre Einsatzdatei wurde vom Server zurückgewiesen.",
		"FEHLER!\n\nWährend Sie versucht haben, dem Spiel noch beizutreten, wurde es vom Spielleiter beendet.",
		"FEHLER!\n\nSie haben zu lange für die Auswahl Ihres Schiffes gebraucht.",
		"FEHLER!\n\nVerbindung zum Server verloren.",
		"FEHLER!\n\nEs konnte kein Port zum Server geöffnet werden.",
		"FEHLER!\n\nEinsatzdaten konnten nicht korrekt eingelesen werden.",
		"FEHLER!\n\nSpielerschiff konnte nicht angemeldet werden.",
		"FEHLER!\n\nUngültige Daten wurden empfangen.",
		"FEHLER!\n\nServerübertragung fehlgeschlagen",
		"FEHLER!\n\nEs ist ein Fehler beim Server während der Schiffszuweisung aufgetreten.",
		"FEHLER!\n\nDer Spielleiter hat das Spiel verlassen. Spiel wird abgebrochen.",
		"FEHLER!\n\nEin oder mehrere Teamcaptains haben das Spiel verlassen. Spiel wird abgebrochen.",
		"FEHLER!\n\nEinsatzdaten konnten nicht korrekt übertragen werden.",
		"Achtung! es konnte keine Verbindung mit Parallax Online aufgenommen werden. Es werden keine PXO-Statistiken aufgezeichnet!",
		"&Abbruch",
		"Pilot wird überprüft...",
		"&OK",
		"Der Pilot wurde von Parallax Online abgelehnt!",
		"Pilot wurde erfolgreich erstellt und angemeldet!",
		"Pilotencheck durch Parallax Online war erfolgreich!",
		"&Abbruch",
		"&Neuer Versuch",
		"Anmeldeversuch fehlgeschlagen wegen Timeouts",
		"Übertragung der Spielerstatistiken...",
		"Parallax-Online-Statistiken wurden aktualisiert!",
		"Parallax-Online-Statistiken wurden NICHT aktualisiert!",
		"Anfordern der Pilotenstatistiken",
		"Herunterladen der Spielerstatistiken von %s\n",
		"Aktualisieren der Spielerstatistiken von %s\n",
		"Ihnen bleiben noch %d Sekunden\n",
		"Schiffsdaten",
		"Staffeldaten",
		"Lebenspunktdaten",
		"Das gewünschte Schiff wurde Ihnen verweigert.",
		"<%s wurde rausgeworfen>",
		"Beobachterschiff",
		"<Ungültiges Bild>",
		"Warte...",
		"Bildübertragung",
		"<kein Bild>",
		"<Bislang keine Einsätze>",
		"->ALLE: ",
		"->VERBÜNDETE: ",
		"->FEINDE: ",
		"->ZIEL: ",
		"<SERVER>",
		"BEFEHL VON <%s> : ",
		"Greifen Sie %s an",
		"Legen Sie %s lahm",
		"Beschützen Sie %s",
		"Ignorieren Sie %s",
		"Entwaffnen Sie %s",
		"Zerstören Sie das Subsystem '%s' von %s",
		"Gehen Sie neben mir in Formation",
		"Geben Sie mir Deckung",
		"Greifen Sie den Feind an!",
		" Server-Übertragung ",
		" Spiel",
		"Server-Übertragung abgeschlossen!",
		"<Nachricht von %s>",
		"&OK",
		"Eine veraltete Version dieser Datei existiert, kann jedoch nicht überschrieben werden, da sie als 'Nur Lesen' markiert werden. Öndern Sie dieses Datei-Attribut, und versuchen Sie es noch mal.",
		"Spieler %s versucht, dem Spiel beizutreten. Erlauben? (j/n)",
		"%s ist beigetreten\n",
		"<%s ist beigetreten>",
		"<%s wurde rausgeworfen>",
		"%s hat das Spiel verlassen",
		"Starterlaubnis erhalten\n",
		"Piloteneinstellungen empfangen",
		"Sie wurden abgelehnt, weil das Spiel sich im Moment in einer Phase befindet, in der kein neuer Spieler zutreten darf.",
		"Sie wurden abgelehnt, weil Sie an keinem PXO-Spiel teilnehmen können, solange Sie kein registrierter PXO-Pilot sind.",
		"Sie wurden abgelehnt, weil das Passwort falsch war.",
		"Sie wurden abgelehnt. Der Einsatz läuft bereits.",
		"Sie wurden abgelehnt. Im Moment ist das Spiel vom Spielleiter gesperrt.",
		"Sie wurden abgelehnt. Das Spiel akzeptiert nur bestimmte Dienstgrade, und Ihrer ist zu hoch.",
		"Sie wurden abgelehnt. Das Spiel akzeptiert nur bestimmte Dienstgrade, und Ihrer ist zu niedrig.",
		"Sie wurden abgelehnt. Ein identischer Spieler befindet sich bereits im Spiel.",
		"Sie wurden abgelehnt. Das Spiel ist bereits vollständig besetzt.",
		"Sie wurden abgelehnt. Sie wurden von diesem Server verbannt.",
		"Sie wurden abgelehnt. Dieses Spiel erlaubt keine Beobachter.",
		"Sie wurden abgelehnt. Jemand anders versucht im Moment, dem Spiel beizutreten. Bitte versuchen Sie es in ein paar Sekunden erneut.",
		"Sie wurden abgelehnt. Ihre Version von FreeSpace ist zu alt für diesen Server. Bitte aktualisieren Sie Ihre FreeSpace-Version. Dies wird über 'Update' im FreeSpace-Launcher durchgeführt.",
		"Waffenposition",
		"Spieler %s versucht, einzusteigen - Erlauben? (j/n)",
		"C",
		"Com",
		"Klasse",
		"Typ",
		"Länge",
		"Geschwindigkeit",
		"%d m/s",
		"Manövrierbarkeit",
		"Panzerung",
		"Lasersockel",
		"Raketenlafetten",
		"Hersteller",
		"Schiffe/Waffen sind noch gesperrt",
		"Schiffe/Waffen sind nun editierbar",
		"Die Piloten wurden noch nicht ihren Schiffen zugewiesen",
		"Sie haben noch nicht alle nötigen Schiffe eingeteilt",
		"Mindestens ein Schiff hat keine Primärwaffe",
		"Mindestens ein Schiff hat keine Sekundärwaffe",
		"Mehr",
		"Netzwerkfehler. Starten Sie FreeSpace neu und versuchen Sie es dann erneut. Wenn auch das nicht funktioniert, starten Sie Ihr System bitte neu.",
		"Keine Spiele gefunden!",
		"Kein Spiel selektiert!",
		"Letzter Vorgang noch in Bearbeitung",
		"Diese Funktion ist noch nicht implementiert!",
		"> 1 sek",
		" ms",
		"<Keine Spielserver gefunden>",
		"Aufbau",
		"Einsatz",
		"Nach",
		"Pause",
		"Im Spiel",
		"Unbekannt",
		"Empfange Spieldaten...",
		"FEHLER!\n\nZeitablauf während der Anforderung",
		"Ein nachträgliches Einsteigen ist bei Team-Spielen nicht möglich",
		"Warten auf Serverrückmeldung...",
		"Server auf dem Kanal: %s",
		"ACHTUNG!\n\nSie haben die Objektaktualisierung auf NIEDRIG gestellt. Ein Server mit dieser Einstellung kann nur einen zusätzlichen Spieler ohne Leistungseinbussen verwalten.",
		"Wenn die Objektaktualisierung auf NIEDRIG gestellt ist, werden nicht mehr als ~2000 Bytes in der Sekunde gesendet. Dies ist ausreichend für Spieler mit 28,8 kBit Modems, für Server aber nicht empfehlenswert. Wenn Sie dies dennoch wollen, sollten sämtliche Spieler die Objektaktualisierung im Optionsmenü (F2) unter 'Multi' ebenfalls auf NIEDRIG eingestellt haben.",
		"ACHTUNG!\n\nSie haben die Objektaktualisierung auf MITTEL gestellt. Ein Server mit dieser Einstellung kann nur einen oder zwei zusätzliche Spieler ohne Leistungseinbussen verwalten.",
		"Wenn die Objektaktualisierung auf MITTEL gestellt ist, werden nicht mehr als ~4000 Bytes in der Sekunde gesendet. Dies ist ausreichend für Spieler mit 28,8 kBit Modems, für Server aber nicht empfehlenswert. Wenn Sie dies dennoch wollen, sollten sämtliche Spieler die Objektaktualisierung im Optionsmenü (F2) unter 'Multi' ebenfalls auf MITTEL eingestellt haben.",
		"&Abbruch",
		"&Ignorieren",
		"&Weitere Informationen",
		"%s Spiel",
		"Temporärer Name",
		"Ungültiger Wert für einen Spielleiter mit Ihrem Dienstgrad (%s)!\n",
		"Leutnant",
		"Lt. ",
		"(B)",
		"Es sind noch nicht alle Mitspieler bereit!",
		"Kein Einsatz ausgewählt!",
		"Kein Feldzug ausgewählt!",
		"Zuviele Beobachter im Spiel\n\nMax: %d\nAktuell: %d\n\nBitte einige davon ausloggen.",
		"Zuviele Spieler im Spiel\n\nMax: %d\nAktuell: %d\n\nBitte einige davon ausloggen.",
		"Teams und/oder Teamcaptains wurden nicht richtig zugeordnet",
		"Sie brauchen für jeweils vier Spieler eine CD!",
		" - ",
		"Achtung!\nDie Anzahl der Leben ist grösser als erlaubt. Das Maximum für diesen Einsatz liegt bei %d",
		"Achtung!\nDas Zeitlimit ist grösser als erlaubt. Das Maximum für diesen Einsatz liegt bei %d",
		"Achtung!\nDie Anzahl der Beobachter ist grösser als erlaubt. Das Maximum für diesen Einsatz liegt bei (%d)",
		"Achtung!\nDas Abschusslimit ist grösser als erlaubt. Das Maximum für diesen Einsatz liegt bei %d",
		"Achtung!\nDie Sprach-Wartezeit ist grösser als erlaubt. Das Maximum für diesen Einsatz liegt bei (>%d)",
		"Starten",
		"Einsatz wird geladen...",
		"Schiffsauswahl",
		"Abschlussbesprechung",
		"Synchronisation",
		"Tritt bei",
		"Beigetreten",
		"Positionen",
		"Schiffsauswahl",
		"Waffenbestückung",
		"Warten...",
		"Im Einsatz",
		"Einsatz geladen",
		"Daten werden geladen...",
		"Bereit zum Einsatz",
		"Schiffsdaten...",
		"Staffeldaten...",
		"Lebenspunktdaten...",
		"Waffendaten...",
		"Daten für Abschlussbesprechung",
		"Einstellungen",
		"Parallax Online Statistiken werden aktualisiert...",
		"Waffendaten...",
		"Spielleiter-\nOptionen",
		"Abschlussbesprechung akzeptiert",
		"Abschlussbesprechung wiederholen ",
		"Waffen-/Schiffsdaten für Feldzug",
		"Einsatzdaten werden übertragen (%d%%)",
		"Einsatzdaten werden übertragen",
		"Server-Synchronisation",
		"Aktualisierungsinformationen senden\n",
		"Dateisignatur anfordern\n",
		"Aktualisierungsinformationen senden",
		"Dateisignatur anfordern",
		"Einsätze...\n",
		"Einsatz wurde lokal geladen\n",
		"Teamauswahl wird aufgerufen...\n",
		"Client führt Synchronisation durch\n",
		"Daten für Einsatzbesprechung senden\n",
		"Waffeneinstellungen abgleichen\n",
		"Spielereinstellungen abgleichen\n",
		"Spiel wird gestartet...\n",
		"Starterlaubnis für Einsatz senden\n",
		"&Ja, aufzeichnen",
		"&Nein, verwerfen",
		"(Spiel wird fortgesetzt)\nWollen Sie diese Statistiken speichern?",
		"(Spiel wird beendet)\nWollen Sie diese Statistiken speichern?",
		"&Verlassen",
		"Sind Sie sicher, dass Sie das Netzwerkspiel verlassen wollen, bevor die Statistiken gespeichert worden sind?",
		"<Statistiken wurden gespeichert>",
		"<Statistiken wurden verworfen>",
		"no other network players are present",
		"zapped",
		"caulked",
		"killed",
		"waxed",
		"popped",
		"murdered",
		"bludgeoned",
		"destroyed",
		"iced",
		"obliterated",
		"toasted",
		"roasted",
		"turned into anti-matter",
		"killed like a pig",
		"taught a lesson",
		"slaughtered with impunity",
		"spanked like a naughty boy",
		"skunked",
		"beat senseless",
		"shot up",
		"spaced",
		"hosed",
		"capped",
		"beat down",
		"hit wit da shizzo",
		"sk00led",
		"whooped up",
		"brought to the all-you-can-take whoop ass buffet",
		"served up a whoop ass sandwich...hold the mercy",
		"gibbed by Kayser Sozay's rocket",
		"shot down",
		"given early retirement",
		"instructed",
		"eviscerated",
		"pummelled",
		"eradicated",
		"cleansed",
		"perforated",
		"canned",
		"decompressed",
		"says",
		"bleats",
		"opines",
		"postulates",
		"declares",
		"vomits out",
		"whines",
		"barks",
		"<%s hat das Spiel verlassen>",
		"Dumping %s after prolonged inactivity",
		"[ipx address here]",
		"Standalone Ship",
		"Stats collected for %7.3f seconds\n",
		"Spielername\tBytes empfangen/s\tBytes gesendet/s\n",
		"Couldn't find network stats for %s ... skipping\n",
		"-------------------------\nTotal:\t%d\t%d\n",
		"\n\nPer Packet Statistics\n---------------\nPacket #\tNum Packets Sent\tTotal Bytes\t%% of total\n",
		"[kein Netzwerk]",
		"Verbindungen : ",
		"Spielleiter verbunden ? Ja",
		"Spielleiter verbunden ? Nein",
		"> 1 sek",
		" ms",
		"Standalone-Server",
		"Primäre Einsatzziele",
		"Sekundäre Einsatzziele",
		"Bonusziele",
		"keine",
		"Baumhierarchie",
		"Der Standalone-Server konnte sich nicht bei Parallax Online anmelden!",
		"VMT Warnung!",
		"<SERVER> %s",
		"OK",
		"Abbruch",
		"Ü&bernehmen",
		"&Hilfe",
		"Abbruch",
		"Verbindungen",
		"Mehrspieler",
		"Spielerinformationen",
		"Cheats",
		"Debug",
		"Freespace Server",
		"Konto &erstellen",
		"Konto ü&berprüfen",
		"PXO-Login wurde abgewiesen. Sie sollten die Parallax Online Webseite besuchen, um sich anzumelden oder Ihre Login-Daten zu überprüfen. Wenn Sie auf 'Abbrechen' klicken, spielen Sie ohne Support von Parallax Online. (Sie können ihn später wieder reaktivieren, indem Sie im 'Multi'-Bereich des Optionendialogs 'PXO' anwählen.)",
		"Kanäle aktualisieren",
		"FEHLER: Anmeldung bei PXO fehlgeschlagen!",
		"Sie wurden rausgeworfen",
		"Sie wurden vom Server getrennt",
		"Achtung!\nWebbrowser konnte nicht gefunden/aufgerufen werden!",
		"Keine Kanäle vorhanden!",
		"Im Moment wird noch versucht, einem anderen Kanal beizutreten!",
		"PXO konnte keine Statistiken für %s finden\n(eventuell kein registrierter PXO-Pilot)",
		"Anmeldung bei PXO fehlgeschlagen!",
		"&Abbruch",
		"Einloggen bei Parallax Online",
		"*** %s hat den Chat verlassen",
		"Verbunden mit Parallax Online",
		"Aktualisiere Liste der öffentlichen Kanäle...",
		"Kanal wechseln...",
		"Kein Kanal (Fehler beim Wechseln)",
		"%s auf Kanal %s",
		"Parallax Online - Kein Kanal",
		"Private Nachricht von ",
		"Private_Nachricht_von ",
		"Private Nachricht an ",
		"Private_Nachricht_an ",
		"Bitte den Name des Kanals zum Beitreten/Öffnen eingeben",
		"Name des gesuchten Spielers:",
		"Suche nach %s...",
		"Spieler wurde nicht gefunden",
		"Spieler ist zwar eingeloggt, aber in keinem Kanal angemeldet",
		"%s befindet sich im Kanal ",
		"%s befindet sich in einem privaten Kanal",
		"Spielerstatistiken werden angefordert",
		"Spielerinformationen werden anfordert",
		"Noch keinen Einsatz geflogen",
		"DirectSound konnte nicht initialisiert werden. Eventuell verwendet eine andere Anwendung im Moment Ihre Soundkarte und blockiert sie damit. In diesem Fall beenden Sie sie bitte vor dem Start von FreeSpace.",
		"Der Microsoft ADPCM-Codec konnte nicht initialisiert werden.\n\nDetaillierte Instruktionen, wie man dieses Problem beheben kann, finden Sie in der README.TXT-Datei.",
		"FEHLER bei der Verbindung zum PXO-Server",
		"FEHLER beim Suchen des PXO-Servers",
		"FEHLER beim Senden von Daten an den PXO-Server",
		"FEHLER beim Erstellen der Versionsdatei",
		"FEHLER beim Empfangen von Daten vom PXO-Server",
		"Ein Fehler ist beim Überprüfen Ihrer Version von FreeSpace aufgetreten. Wenn Sie diesen Fehler ignorieren, werden Sie möglicherweise nicht auf dem neuesten Stand sein.",
		"Die Versionsdatei konnte nicht geöffnet werden.",
		"Eine neuere Version von FreeSpace ist verfügbar. Sie müssen Ihr Spiel zur neuesten Version aktualisieren, um auf PXO zu spielen.\n\nSoll der Aktualisierungsvorgang jetzt durchgeführt werden?",
		"FreeSpace-Version wird überprüft",
		"Vorherigem Kanal wieder beitreten (",
		"Konnte dem vorherigen Kanal nicht beitreten.",
		"Automatischer Beitritt zum Standardkanal",
		"Automatischer Beitritt zum Standardkanal nicht möglich.",
		"Sie müssen Ihre Verbindungsgeschwindigkeit im Launcher unter Setup/Netzwerk einstellen.",
		"Ein Fehler ist beim Lesen der Missionsdatei aufgetreten. Die Datei enthält ungültige Daten.",
		"Konnte die Datei FREESPACE2.EXE nicht automatisch vom temporären Update-Verzeichnis (in Ihrem FreeSpace-Verzeichnis) in Ihr FreeSpace-Verzeichnis selbst kopieren. Bitte kopieren Sie diese Datei von Hand.",
		"\nBitte warten...\n%s",
		"\nBitte warten...\n%s",
		"\nBitte warten...",
		"\nBitte warten...",
		"Sie benötigen die FreeSpace-Missionsdisk, um diesem Netzwerkspiel beitreten zu können.",
		"",
		"&Zurück",
		"",
		"",
		"Sie wurden rausgeworfen, da die Übertragung der Einsatzdaten fehlgeschlagen ist",
		"Sie wurden rausgeworfen, weil Sie die FS-Einsatzdatei nicht besitzen",
		"Sie wurden rausgeworfen, da das Spiel mittlerweile beendet wurde",
		"<PXO-Statistiken wurden gespeichert>",
		"<Speichern der PXO-Statistiken fehlgeschlagen für %s>",
		"<%s wurde rausgeworfen - Übertragung der Einsatzdaten fehlgeschlagen>",
		"<%s wurde rausgeworfen - FS-interner Einsatz %s fehlt>",
		"<%s wurde rausgeworfen - Spiel war bereits zu Ende>",
		"Achtung!\n\nDieser Spieler hat bereits über PXO gespielt. Wenn Sie weitermachen und ein nicht-PXO Spiel spielen, werden Ihre Statistiken nicht aktualisiert",
		"Dienstgrad",
		"Geflogene Einsätze",
		"Flugerfahrung",
		"Zuletzt geflogen",
		"Abschüsse ",
		"Primärwaffen-Schüsse",
		"Primärwaffen-Trefferquote",
		"Sekundärwaffen-Schüsse",
		"Sekundärwaffen-Trefferquote",
		"Senkrechte Achse",
		"Querachse",
		"Längsachse",
		"Absolute Schubregulierung",
		"Relative Schubregulierung",
		"Joystick/Maus X-Achse",
		"Joystick/Maus Y-Achse",
		"Joystick Z-Achse",
		"Joystick rX-Achse",
		"Joystick rY-Achse",
		"Joystick rZ-Achse",
		"Linke Taste",
		"Rechte Taste",
		"Mittlere Taste",
		"L/R",
		"O/U",
		"N",
		"J",
		"Neu",
		"&Weiter",
		"Optionen",
		"&Orden",
		"&Löschen",
		"OK",
		"Clonen",
		"Solo",
		"Multi",
		"Konvertieren",
		"<Der Server hat eine manipulierte SHIPS.TBL erkannt. Statistiken werden nicht gespeichert>",
		"Sie spielen mit einer manipulierten SHIPS.TBL-Datei. Ihre Statistiken werden nicht gespeichert.",
		"<Der Server hat eine manipulierte WEAPONS.TBL erkannt. Statistiken werden nicht gespeichert>",
		"Sie spielen mit einer manipulierten WEAPONS.TBL-Datei. Ihre Statistiken werden nicht gespeichert.",
		"<Nicht genug Spieler waren am Spielanfang und/oder -ende anwesend. Statistiken werden nicht gespeichert>",
		"<Der Server hat einen nicht für PXO freigegebenen Einsatz erkannt. Statistiken werden nicht gespeichert>",
		"Dies ist kein für PXO freigegebener Einsatz. Ihre Statistiken werden nicht gespeichert.",
		"Sie oder der Server haben eine manipulierte SHIPS.TBL. Ihre Statistiken werden nicht aktualisiert auf PXO.",
		"Sie oder der Server haben eine manipulierte WEAPONS.TBL. Ihre Statistiken werden nicht aktualisiert auf PXO.",
		"<Fehler>",
		"Wir haben dem nichts hinzuzufügen.",
		"Technische Datenbank",
		"Einsatzsimulator",
		"Filmsequenzen",
		"Das Team ",
		"Spiel",
		"Einzeleinsätze",
		"Feldzugeinsätze",
		"Starten",
		"Einsatz",
		"Dateiname",
		"Waffen",
		"Geschichte",
		"Schiffsauswahl",
		"Waffenbestückung",
		"Weiter",
		"Ereignisse",
		"Einsatzziele",
		"Meldungen",
		"Für Squad War brauchen Sie mindestens %d Piloten pro Geschwader ",
		"Bitte warten...\n%s",
		"Bitte warten...\nAnmelden bei SquadWar",
		"Bitte geben Sie den Matchcode ein",
		"Squadwar Match konnte nicht angemeldet werden. Bitte stellen Sie sicher, dass Sie den korrekten Code eingegeben haben und dass sämtliche Teilnehmer einem der beiden geschwader zugeteilt wurden.",
		"Bitte warten...\nSquadWar-Resultate registrieren",
		"<SquadWar-Resultate wurden von PXO angenommen>",
		"<SquadWar-Resultate wurden von PXO abgewiesen>",
		"%s starb durch einen Geschützstrahl unbekannter Herkunft",
		"%s wurde von %s mit einem Geschütztreffer getötet",
		"Keine 3D-Beschleunigung",
		"Grafik",
		"Aktueller Grafikmodus:",
		"FreeSpace setzt eine 3D-Grafikkarte voraus. Suchen Sie die passende Option aus der obigen Liste aus.",
		"3D-Karten suchen",
		"Optionen:",
		"Filmsequenzen im Interlaced-Modus abspielen",
		"Filmsequenzen im FastClear-Modus abspielen",
		"Niedrige Direct3D-Texturdetails (beschleunigt Spiel)",
		"Freespace braucht Glide oder Direct3D (per Hardware). Ohne diese Hilfe läuft das Spiel nicht.",
		"Achtung!",
		"OK",
		"Muss aktualisiert werden",
		"Muss installiert werden",
		"Windows NT hat DirectX eingebaut. Wenn Sie Windows NT 4.0 als Betriebssystem verwenden, sollte Ihr System mindestens auf Service Pack-Ebene 3 (SP3) sein. Für detailierte Informationen über NT Service Packs (inkl. Downloadlinks) gehen Sie bitte zu dieser Website\n%s.\n\nWollen Sie sie jetzt besuchen?",
		"Sie haben eine ältere Version von DirectX als Version 5.0. Wir empfehlen Ihnen, DirectX 5.0 auf Ihrem Rechner zu installieren.\n\nMöchten Sie das jetzt tun?\n\n",
		"Ihre Version von DirectX ist auf dem neuesten Stand.\nWeitere Informationen zur aktuellen Version von DirectX (einschliesslich einiger Links zum Download) finden Sie unter \n%s.\n\nWollen Sie diese Website jetzt besuchen?",
		"DirectX-Versionsinformation",
		"Ihre DirectX-Version",
		"Diagnose",
		"Freespace braucht DirectX 3.0 (oder besser). Direct3D, Force Feedback und Direct Sound 3D setzen DirectX 6.0 voraus.",
		"DirectX installieren/aktualisieren",
		"FreeSpace Launcher",
		"FreeSpace-Demo-Launcher",
		"FEHLER: Das Betriebssystem meldet, dass zu wenig Ressourcen frei sind.",
		"FEHLER: Die .EXE-Datei hat eine unerlaubte Signatur.",
		"FEHLER: Das Betriebssystem hat den Zugriff auf die angegebene Datei verweigert.",
		"FEHLER: Es existiert keine Verbindung mit dem Dateiprotokoll/typ.\r\n(Sie müssen Ihren Web-Browser als Standard definiert haben)",
		"FEHLER: Die DDE-Anfrage konnte nicht abgeschlossen werden, da andere DDE-Transaktionen im Gange sind.",
		"FEHLER: Die DDE-Anfrage ist fehlgeschlagen.",
		"FEHLER: Die DDE-Anfrage konnte wegen eines Zeitüberlaufs nicht abgeschlossen werden.",
		"FEHLER: DLL-Datei nicht gefunden.",
		"FEHLER: Zu wenig freier Speicher.",
		"FEHLER: Ein Fehler bei der Freigabe ist aufgetreten.",
		"\r\nEs konnte kein Webbrowser gefunden werden.\r\nBitte installieren Sie einen Browser und definieren Sie ihn als Standardbrowser.\r\n\r\n",
		"FEHLER: Ein unbekannter Fehler ist aufgetreten.",
		"Achtung!",
		"Sie müssen Freespace zunächst konfigurieren.\n\nKlicken Sie dazu auf 'Setup' im Launchermenü, und gehen Sie dann die verfügbaren Optionen nach und nach durch. Wenn Sie damit fertig sind, bestätigen Sie die Einstellungen mit OK.",
		"Sie müssen einen Grafikmodus auswählen!",
		"Sie müssen Freespace zunächst erlauben, die nötigen Einstellungen für Ihre Grafikkarte vorzunehmen, bevor Sie FreeSpace spielen können.\n\nKlicken Sie dazu auf 'Setup' im Launchermenü, und wählen Sie die Seite 'Grafik'. Lassen Sie das Programm dort nach verfügbaren Grafikkarten suchen, und wählen Sie den gewünschten Grafikmodus aus. Klicken Sie schliesslich unten auf 'OK'.",
		"Sie benötigen DirectX 3.0 oder höher!",
		"Sie müssen zumindest DirectX 3.0 installieren, um Freespace spielen zu können.\n\nIm 'Setup'-Dialog im Launcher unter 'DirectX' bekommen Sie nähere Informationen.",
		"Fehler beim Starten von FreeSpace",
		"Setup",
		"Fehler beim Laden der README-Datei",
		"Keine Deinstallations-Informationen gefunden",
		"Sind Sie sicher, dass Sie '%s' und alle dazugehörigen Komponenten entfernen wollen?",
		"Bestätigung",
		"Deinstallationsprogramm konnte nicht gestartet werden",
		"Willkommen bei Freespace!",
		"Da dieses der erste Aufruf von FreeSpace auf Ihrem Computer ist, wird nun der Setup-Dialog gestartet, der Ihnen hilft, FreeSpace zu konfigurieren.\n\nACHTUNG!\nEs ist wichtig, dass Sie alle Bereiche des Setup-Dialoges durchgehen und korrekt konfigurieren. Das Hilfe-Symbol wird Ihnen bei Fragen zu einer bestimmte Sektion weiterhelfen. Sobald Sie sicher sind, alles richtig eingestellt zu haben, drücken Sie auf OK, um die Einstellungen für künftige Spielrunden zu speichern.",
		"Joystick",
		"<Keiner>",
		"Aktueller Joystick",
		"Force Feedback aktivieren",
		"'Directional Hit' bei Force Feedback aktivieren",
		"Kalibrieren",
		"Angeschlossene Joysticks suchen",
		"Bitte legen Sie FreeSpace-CD 1 ein, und klicken Sie auf OK.",
		"Sonstiges",
		"Sprache",
		"Befehlszeilenparameter (optional)",
		"Deinstallation fehlgeschlagen",
		"Netzwerk",
		"Verbindung mit dem Internet",
		"Internetgeschwindigkeit",
		"nicht vorhanden",
		"per DFÜ-Netzwerk",
		"per LAN/Direktverbindung (und AOL)",
		"Nicht angegeben",
		"weniger als 56 KBit (28,8 oder 33.6 Modem)",
		"56 KBit",
		"64 KBit (ISDN)",
		"128 KBit (Dualkanal ISDN, Kabelmodem)",
		"mehr als128 KBit (T1, ADSL, T3, ...)",
		"Fehler beim Lesen der CD.",
		"Geschwindigkeit",
		"Niedrig",
		"Mittel",
		"Hoch",
		"Sehr hoch",
		"Voreingestellte Detailstufe:",
		"Eigenschaften",
		"Prozessor:",
		"Prozessortakt:",
		"Hauptspeicher:",
		"RAM-Transferrate:",
		"VRAM-Transferrate:",
		"3D-Grafikbeschleuniger*:",
		"*Wie unter 'Grafik' eingestellt.",
		"Analyse starten",
		"Audio",
		"Es wurde eine Aureal-Soundkarte erkannt, jedoch sind die Treiber nicht aktuell genug. Bitte laden Sie diese von www.a3d.com runter.",
		"Dies ist eine A3D-Version, die nicht von Aureal zertifiziert wurde.\nBitte aktualisieren Sie Ihre Treiber: www.a3d.com",
		"Kein Sound",
		"Aktuelle Soundkarte",
		"Soundkarten suchen",
		"Im Launcher Soundeffekte spielen",
		"Der Freespace Launcher muss aktualisiert werden.\nAllerdings konnte entweder auf die neue EXE oder auf die Patch-Datei nicht zugegriffen werden.\n\nDeswegen kann er zu diesem Zeitpunkt nicht aktualisiert werden.",
		"Der Freespace Launcher muss aktualisiert werden.\nAllerdings wurde Launcher.EXE nicht gefunden oder der Zugriff darauf verweigert.\n\nDeswegen kann er zu diesem Zeitpunkt nicht aktualisiert werden.",
		"Der Freespace Launcher muss aktualisiert werden.\nEr wird nun beendet, aktualisiert und dann neugestartet.\n\nDies kann ein paar Sekunden dauern...",
		"Launcher-Aktualisierung ",
		"Fehler!",
		"Auf aktuellem Stand",
		"Bereit",
		"Suchen Sie einen Mirrorserver aus",
		"Aktualisierung ist fehlgeschlagen!",
		"Verbinden...",
		"Download...",
		"Weiterverbinden...",
		"Download abgebrochen",
		"<Keine Informationen>",
		"Vorgang kann nicht fortgesetzt werden! Klicken Sie auf 'Abbrechen'.",
		"Fehler",
		"Datei konnte nicht gefunden werden",
		"HTTP-Fehlercode %d",
		"Download der Serverinformationen...",
		"Download der Versionsinformationen...",
		"Download der Mirrorserverinformationen...",
		"Fehler beim Verarbeiten der Mirrorserverinformationen.",
		"Herunterladen der Aktualisierungsdaten",
		"Download %d Bytes von %d  (%d%%)",
		"Fehler beim Verarbeiten der Versionsinformationen.",
		"Das automatische Update-Programm von Freespace konnte in der Systemregistrierung keine Information über Ihre derzeitige Spielversion finden.\n\nDas sollte leicht zu beheben sein, indem Sie das Spiel einfach starten und sofort wieder verlassen, bevor Sie das Auto-Update-Programm erneut starten.",
		"Fehler bei der Überprüfung der Versionsnummer",
		"Klicken Sie auf OK, um die neue Version von FreeSpace herunterzuladen!",
		"Eine neue Version von Freespace ist verfügbar! Klicken Sie auf OK, um Sie herunterzuladen.",
		"Keine Aktualisierung erforderlich.",
		"Sie sind auf dem neuesten Stand (Freespace V%d.%d.%d).",
		"Fehler beim Aktualisieren",
		"Verarbeite %s",
		"Datei abgeschlossen!",
		"Informationen werden verarbeitet...",
		"Aktualisierung fehlgeschlagen!",
		"Keine Daten für die Aktualiserung.",
		"Keine Daten für die Aktualiserung. Freespace kann nicht aktualisiert werden.",
		"Aktualisierung wird nun durchgeführt...",
		"Aktualisierung ist abgeschlossen!",
		"FEHLER: Ungültige URL",
		"FEHLER: Die Mirrorseite versucht, zu einem nicht angegebenen Server weiterzuleiten.",
		"FEHLER: Zuwenig Festplattenspeicherplatz zum Download der Datei: ",
		"Fehler beim Herunterladen",
		"Fehler beim Schreiben",
		"Sie müssen zunächst einen Mirrorserver auswählen.",
		"Mirrorserver",
		"Sie müssen zunächst einen Mirrorserver auswählen.",
		"Anbieter",
		"URL",
		"Standort",
		"Fehler beim Auswerten der Mirrorserver-Informationsdatei.",
		"Freespace Auto-Update",
		"Aktuelle Informationen:",
		"Installiert:",
		"Aktuell:",
		"Fortschritt:",
		"Status:",
		"Verfügbare Mirrorserver",
		"Bitte wählen Sie den Mirrorserver, von dem Sie den Patch herunterladen wollen:",
		"Aktualisieren des Freespace Launchers...",
		"Bitte warten...",
		"FEHLER: Dieses Programm wurde nicht vom Launcher gestartet!",
		"FEHLER: Datei %s nicht gefunden.",
		"FEHLER: Dateizugriff verweigert: %s.",
		"FEHLER: Datei %s konnte nicht gelöscht werden.",
		"FEHLER: Datei %s konnte nicht umbenannt werden.",
		"FEHLER: Die Aktualisierungs-DLL unterstützt die vom Programm angegebene Funktion nicht. Bitte installieren Sie neu.",
		"FEHLER: Die Aktualisierung konnte nicht abgeschlossen werden.",
		"Starten des alten Freespace Launchers...",
		"Starten des neuen Freespace Launchers...",
		"FEHLER: Der Launcher konnte nicht neu gestartet werden.",
		"Freespace Launcher - Fehler beim Aktualiseren",
		"Der Launcher wurde nicht aktualisiert.",
		"<Nicht zugeteilt>",
		"Alle",
		"Coop",
		"Team",
		"Raumkampf",
		"Aktualisieren",
		"Spielerinfo",
		"Einsätze",
		"Feldzüge",
		"1",
		"2",
		"Raus!",
		"Optionen",
		"Spielrunde anlegen",
		"Spieler",
		"Sperre",
		"verwendet manipulierte FreeSpace-Dateien",
		"Einer oder mehrere Spieler verwenden manipulierte FreeSpace-Dateien.\n\nSquadWar kann nur dann gespielt werden, wenn alle Teilnehmer die Orginaldateien besitzen",
		"Einer oder mehrere Spieler verwenden manipulierte FreeSpace-Dateien.\n\nWenn Sie weitermachen, werden keine Statistiken am Ende des Einsatzes gespeichert",
		"Einer oder mehrere Spieler verwenden manipulierte FreeSpace-Dateien",
		"<Team 1 hatte %d Punkte>",
		"<Team 2 hatte %d Punkte>",
		"<Das Match endete unentschieden>",
		"<Team 1 (Grün) hat gewonnen>",
		"<Team 2 (Rot) hat gewonnen>",
		"Ranghöchster",
		"Teamcaptain",
		"Jeder",
		"Spielleiter",
		"Schwierigkeitsgrad",
		"An",
		"Aus",
		"Spielleiter verändert Schiffe",
		"Anzahl Leben",
		"KI-Befehlsgewalt",
		"Berechtigung, Einsatz zu beenden",
		"Zeitlimit",
		"Min",
		"Abschusslimit",
		"Beobachter",
		"Audioübertragung",
		"Audioqualität",
		"Nachrichtenlänge",
		"Sprach-Wartezeit",
		"Aktualisieren",
		"Beobachter",
		"Modus",
		"eröffnen",
		"Beitreten",
		"Status",
		"Server",
		"Spieler",
		"Ping",
		"Team 1",
		"Team 2",
		"Spieler",
		"Info",
		"Teamauswahl",
		"Web-",
		"Rangliste",
		"Suche",
		"Meldung des Tages",
		"Kanal",
		"Kanal",
		"Spiele",
		"Geschwader",
		"Kanäle",
		"Offen",
		"Geschlossen",
		"Auf Anfrage",
		"mit Passwort schützen",
		"auf den Dienstgrad beschränken",
		"Mindestens",
		"Höchstens",
		"Neues Spiel öffnen",
		"Bezeichnung",
		"Spieltyp",
		"Passwort eingeben",
		"Statistiken",
		"Empfehlungen",
		"Starten",
		"Bitte warten...",
		"Standard",
		"%s wird von Teamkamerade %s abgeschossen",
		"%s stirbt durch einen Geschütztreffer aus dem eigenem Team (%s)",
		"Zielen",
		"Schiff",
		"Inversion",
		"UnDo",
		"Standard",
		"Suche",
		"Zuweisen",
		"Konflikt",
		"lösen",
		"löschen",
		"löschen",
		"Details",
		"Steuerung",
		"konfigurieren",
		"Cockpit",
		"Voreinstellung",
		"Benutzerdefiniert",
		"Planeten/Hintergründe",
		"Zielsicht-Rendering",
		"Waffeneffekte",
		"Modelldetails",
		"Nebeldetails",
		"3D-Hardwaretexturen",
		"Partikel",
		"Explosionseffekte",
		"Schildeffekte",
		"Sterne",
		"Lichteffekte",
		"Sprachausgabe bei Einsatzbesprechungen",
		"Lautstärke",
		"Effekte",
		"Musik",
		"Sprachausgabe",
		"Maus",
		"Empfindlichkeit",
		"Helligkeit",
		"Joystick",
		"Toleranzzone",
		"TCP",
		"IPX",
		"IP-Adressen",
		"(+)",
		"(-)",
		"PXO",
		"Benutzername",
		"Passwort",
		"Geschwader",
		"LAN durchsuchen",
		"Generell",
		"Mikrotest",
		"Stumm",
		"Objektaktualisierung",
		"LAN",
		"Spieler-/Staffel-Bilder",
		"Ja",
		"Nein",
		"Einsätze übertragen nach",
		"/multidata",
		"/missions",
		"Cache löschen",
		"Nie",
		"Beim Spielstart",
		"Sie haben IPX-Protokoll als Protokoll ausgewählt, aber dieses Protokoll ist auf Ihrer Maschine nicht installiert.",
		"Feldzug",
		"neu starten",
		"Wiederholen",
		"Empfange Meldung",
		"Abgeschlossen",
		"Spiel",
		"Wählen",
		"Einsatz",
		"Andere",
		"beenden",
		"Alle",
		"Auswahl",
		"Konfig.",
		"Verlassen",
		"Zurück",
		"Zurück",
		"Zurück",
		"Zurück",
		"Sie haben sich mit der Druckwelle Ihrer Rakete selbst umgebracht ",
		"Sie haben sich mit der eigene Rakete umgebracht",
		"Name",
		"Klasse",
		"Status",
		"Primär",
		"Sekundär",
		"Rumpfschaden",
		"Triebwerksstrahl",
		"Ausgewichen",
		"Kollision",
		"Vorherigen Einsatz erneut spielen",
		"Sie können keinem bereits gestartetes Spiel beitreten (ausser Raumkampf).",
		"Pilotenquartier",
		"Dienstakte",
		"Wählen Sie einen Piloten aus",
		"Erledigt",
		"Unerledigt",
		"Fehlgeschlagen",
		"Spielpause",
		"Drücken Sie ESC, um zum Spiel zurückzukommen",
		"Training überspringen",
		"Nicht &mehr anzeigen",
		"&Nächster Tip",
		"Sie können das Geschwader im Solospieler-Modus nicht wechseln.",
		"Bitte konfigurieren Sie zunächst Ihr System im Launcher, vorher kann FS nicht gestartet werden.\n\nDer Launcher wird jetzt gestartet!",
		"Achtung!",
		"Achtung! Freespace benötigt eine 3D-Grafikkarte, die Glide oder Direct3D unterstützt. Sonst können sie FreeSpace nicht spielen.",
		"Achtung!",
		"Der Launcher konnte nicht neu gestartet werden.",
		"Fehler",
		"Vorheriger Einsatz",
		"Bei Bedarf",
		"Speichern",
		"Beige",
		"Blau",
		"Grün",
		"Helligkeit",
		"Warnblinken",
		"Kommunikationsmenü",
		"Versorgungsanzeige",
		"Netzwerk-Verzögerung",
		"Auto",
		"Schub",
		"Visier",
		"Zurück",
		"Ablehnen",
		"Bitte legen Sie CD %d ein",
		"Mehr",
		"Das war der fünfte Fehlversuch bei diesem Einsatz.",
		"Wenn Sie wollen, dürfen Sie ihn jetzt überspringen und mit dem nächsten weitermachen.",
		"Das war der fünfte Fehlversuch bei diesem Einsatz. Wenn Sie wollen, dürfen Sie ihn jetzt überspringen und mit dem nächsten weitermachen.",
		"Einsatz weiter versuchen",
		"Zum nächsten Einsatz springen",
		"Diesen Dialog nicht mehr anzeigen",
		"Selbstzerstörung",
		"Spezialeinheit verlassen",
		"SquadWar-Ergebnisse für ungültig erklärt",
		"\r\nDie FRED-Hilfedatei ist nicht aufzufinden: \\data\\freddocs\\index.html\r\n",
		"DirectDraw konnte nicht initialisiert werden. DirectDraw V6.0 oder höher\nist Voraussetzung, um FreeSpace spielen zu können.",
		"Achtung!",
		"Sie müssen zumindest einmal FreeSpace selber starten, um die Versionsinformationen zu registrieren.",
		"Die Daten von '%s' stimmen nicht mit denen der Patchdatei überein. Die Aktualisierung wurde abgebrochen. Bitte versuchen Sie es mit einer Neuinstallation des Spiels. Untersuchen Sie ausserdem Ihr System auf Viren!\n\n",
		"Wenn das Problem weiterhin besteht, sollten Sie Volitions Support kontaktieren unter support@pxo.net.",
		"Suche Direct3D-Karte",
		"Suche Glide-Karte",
		"Geschützturm",
		" Subsystem gescannt, Fracht: ",
		"Spezialeinheit verlassen\n\n\n\nSind Sie sicher, dass Sie die Spezialeinheit verlassen wollen?",
		"<Keine Sondereinheiten-Einsatzbeschreibung verfügbar>",
		"\n\n\nWollen Sie die optionalen Einsätze spielen?",
		"OK",
		"Nichts",
		"%s stirbt im Triebwerksstrahl von %s",
		"FreeSpace kann nur maximal %d Schiffe auf einmal in einem Einsatz verwalten. Bitte sorgen Sie dafür, dass in Ihrem Einsatz nicht mehr als %d Schiffe gleichzeitig auftauchen können.",
		"Ein Fehler ist beim Aktualisieren des Launchers 'FreeSpace2.exe' aufgetreten.\nDie anderen Dateien konnten dagegen erfolgreich aktualisiert werden.\nSie sollten den Launcher manuell herunterladen:\n\n",
		"\n\nWollen Sie die Webseite jetzt öffnen?",
		"Fehler beim Aktualisieren des Launchers",
		"'Vertex fog' oder 'Table fog'\r\n",
		"Bitte warten...\nAnmelden beim Spielserver",
		"<%s wird rausgeworfen...>",
		"WFOG erzwingen (nicht empfehlenswert)",
		"Direct3D ZBuffer Bias deaktivieren",
		"Einsatzbesprechung",
		"Öffentlicher",
		"Privater",
		"Alarm! Rakete!",
		"Sperren",
		"Schwierigkeitsgrad",
		"Alt",
		"Shift",
		"R",
		"G",
		"B",
		"I",
		"Abbrechen",
		"Löschen",
		"Standard",
		"Hilfe",
		"Optionen",
		"OK",
		"sek",
		"sek",
		"&Abbrechen",
		"&Ignorieren",
		"Punkte in diesem Einsatz",
		"Punkte",
		"Sprachausgabe",
		"Empfindlichkeit",
		"Audioübertragung",
		"Audioqualität",
		"Name",
		"Dienstgrad",
		"Abschüsse",
		"Unterstützung bei",
		"Abschüsse von Verbündeten",
		"Geflogene Einsätze",
		"Flugerfahrung",
		"Zuletzt geflogen",
		"Schüsse Primärwaffen ",
		"Treffer Primärwaffen ",
		"Trefferquote Primärwaffen",
		"Schüsse Sekundärwaffen ",
		"Treffer Sekundärwaffen ",
		"Trefferquote Sekundärwaffen",
		"Sekundärwaffen-Treffer Verb.",
		"=> Quote",
		"Sekundärwaffen-Treffer Verb.",
		"=> Quote",
		"Alles",
		"auswählen",
		"Weiter",
		"Waffen",
		"32-Bit suchen",
		"Hi-Res suchen",
		"PXO-Konto ",
		"Login",
		"Passwort",
		"Kein PXO-Versionstest",
		"PXO-Banner",
		"Diverses",
		"Lokaler Port fest ",
		"Deutsch",
		"Englisch",
		"TIPS FÜR EINSTEIGER\n\n%s",
		"Flakturm",
		"Strahlgeschütz",
		"Laserturm",
		"Raketenwerfer"		
	},

	// French
	{
		"Vaisseau du joueur à présent %s",
		"Cible du joueur à présent %s",
		"Bande son à présent : %s",
		"La musique n'est pas activée",
		"Délai du débit de trames augmenté à %i millisecondes par trame.",
		"Délai du débit de trames abaissé à %i millisecondes par trame.",
		"Tirs de leurres : %s",
		"ACTIVE",
		"DESACTIVE",
		"Votre coque a subi %7.3f de dégâts après cet accrochage.\n",
		"Vous êtes %s",
		"INDESTRUCTIBLE !!",
		"vulnérable...",
		"La cible du joueur [%s] est %s",
		"Infos de débogage sur l'objet #%d",
		"Energie des armes / nombre de missiles : maximum pour tous les vaisseaux!",
		"Energie des armes / nombre de missiles : maximum pour le joueur",
		"Energie des armes / nombre de missiles : normaux",
		"Arme secondaire : %s",
		"Arme principale : %s",
		"",
		"Musique évènementielle désactivée",
		"Niveau détail : %+d\n",
		"Test débit trames commencé",
		"Genre de cibles à présent : %s",
		"Niveau de difficulté : %s.",
		"Aucune cible à ajouter/retirer du groupe %d.",
		"Ajout de %s au groupe %d. (F%d)",
		"&Oui, Quitter",
		"Oui, &Redémarrer",
		"Voulez-vous vraiment terminer la mission?",
		"Codes triche activés.",
		"Vidéos disponibles dans salle technique ",
		"Ce vaisseau n'a pas d'armes secondaires",
		"Arme secondaire réglée sur mode de tir normal",
		"Arme secondaire réglée sur mode de double tir ",
		"Caméra extérieure verr., commandes affecteront le vaisseau",
		"Caméra extérieure libre, les commandes affecteront la caméra",
		"Portée radar réglée sur %s",
		"* ATTENTION * Danger de collision. Distorsion non activée.",
		"Moteur défectueux. Impossible de transiter.",
		"&Réessayer",
		"&Ignorer",
		"&Quitter jeu",
		"Attention\nEchec de sauv. du fichier Pilote. Vous n'avez peut-être pas assez d'espace disque. Appuyez sur Alt-Tab, revenez et réessayez.\n",
		"",
		"",
		"&Non",
		"&Oui",
		"Attention\nCe pilote existe déjà.\nEcraser?",
		"*Historique des performances",
		"Tirs de l'arme principale : ",
		"Arme principale - Tirs réussis :",
		"Arme principale - Tirs sur alliés :",
		"Arme principale - Tirs réussis :",
		"%.1f%%",
		"Arme principale - Tir sur allié :",
		"Tirs de l'arme secondaire :",
		"Arme secondaire - Tirs réussis :",
		"Arme secondaire - Tirs sur alliés :",
		"Arme secondaire - Tirs réussis :",
		"Arme secondaire - Tirs sur alliés :",
		"Nombre de vaisseaux détruits :",
		"Contributions :",
		"*Vict. par type de vaisseau",
		"Attention !\n\nVoulez-vous vraiment effacer ce pilote ? ",
		"Vous devez créer un pilote un seul joueur.",
		"Vous devez créer un pilote multijoueur.",
		"multijoueur",
		"un seul joueur",
		"Ceci effacera votre pilote (%s). Continuer ?",
		"%d sur %d",
		"médailles",
		"pause",
		"armement",
		"vue du haut",
		"vue du joueur",
		"vue précédente",
		"zoom in",
		"zoom out",
		"Appuyez sur Echap pour sortir",
		"Impossible de transiter maintenant.",
		"Impossible de transiter... le vaisseau doit atteindre %.1f km/s",
		"passagers :\n   %s",
		"carg. : %s",
		"Scanné",
		"carg. : <inconnue>",
		"non scanné",
		"carg. : inspection en cours",
		"scan en cours",
		"missile",
		"tir laser",
		"%s a été tué par l'onde de choc d'un missile ",
		"%s a été tué par l'onde de choc résultant de l'explosion d'1 %s",
		"%s a été tué par %s",
		"%s a été tué par l'explosion d'1 %s",
		"%s a été tué lors d'une collision avec 1 %s",
		"%s a été tué lors d'une collision avec des débris",
		"%s a été tué par une collision avec un astéroïde",
		"%s est mort dans des conditions inconnues",
		"Vous vous êtes tué",
		"vue aérienne",
		"vue arrière",
		"vue gauche",
		"vue droite",
		"Démarrage rapide de mission",
		"Retourner sur le pont",
		"Retourner au briefing",
		"Mode observateur",
		"Régénération",
		"Attention\nToutes les avancées de votre \ncampagne actuelle seront perdues",
		"La démo de campagne est terminée. Voulez-vous recommencer ?",
		"La campagne est terminée. Pour recommencer, créez un nouveau pilote ou redémarrez-la dans la salle de campagne.",
		"Attention\n Toutes les avancées de la campagne ",
		"Résultats de mission",
		"Victoires totales",
		"Tirs de l'arme principale",
		"Arme principale - Tirs réussis",
		"Arme principale - Tirs sur alliés",
		"Arme principale - Tirs réussis",
		"Arme principale - Tir sur allié",
		"Tirs de l'arme secondaire",
		"Arme secondaire - Tirs réussis",
		"Arme secondaire - Tirs sur alliés",
		"Arme secondaire - Tirs réussis",
		"Arme secondaire - Tirs sur alliés",
		"Contributions",
		"Joueurs morts",
		"Historique des performances",
		", ",
		"Non affectée",
		" - ",
		"Page %d sur %d",
		"Touches basiques",
		"Touches de fonction",
		"F1",
		"aide contextuelle",
		"F2",
		"ecran d'options (disponible partout dans le jeu)",
		"F3",
		"affectation des touches rapides ",
		"F4",
		"Défilement des messages du cockpit",
		"F5...F12",
		"touches rapides",
		"Maj-Echap",
		"Quitter FreeSpace immédiatement",
		"Touches de mouvement",
		"La cible : touches de base",
		"Touches de ciblage élaboré",
		"(fr)select target assigned to that hotkey",
		"Maj-F5...F12",
		"(fr)add/remove target from that hotkey",
		"Alt-Maj-F5...F12",
		"(fr) clear that hotkey",
		"Messagerie",
		"envoyer des ordres spécifiques à ces cibles",
		"Utilisation des armes",
		"Touches de gestion d'énergie",
		"Touches diverses",
		"ECHAP",
		"afficher menu d'abandon de mission",
		"Pause",
		"mettre le jeu en pause",
		"Impr écran",
		"faire une photo d'écran",
		"Touches de vue ",
		"Touches multijoueurs",
		"Touches messagerie (texte: appuyez , voix: gardez enfoncée)",
		"Echec du chargement de mission",
		"Démo de FreeSpace",
		"FreeSpace",
		"Cette version de Freespace a été compilée pour\n\n",
		"\n\nApp. sur OK pour continuer.\n",
		"NE PAS DISTRIBUER !",
		"Cette version de Freespace a été compilée pour",
		"App. sur une touche pr continuer.",
		"Votre chasseur n'a presque plus d'essence. Vérifiez sous le \ncapot et ajoutez-en si besoin est.",
		"Freespace est fatigué. Il se désactive pour se reposer un peu.",
		"Temps de mission restant : %d sec.",
		"Nb d'octets lus : %d",
		"Nb d'octets écrits : %d",
		"Vue ext. du vaisseau du joueur.",
		"Vue de l'int. du vaisseau du joueur.",
		"n¬úud de transit",
		"Vue%s%s\n",
		"de ",
		"Vue de l'observateur\n",
		"Vue subjective\n",
		"Démarrage rapide de mission",
		"Retourner sur le pont",
		"Retourner au briefing",
		"Vous êtes mort",
		"Vous n'avez que %d Mo de mémoire disponible.\n\n FreeSpace nécessite au moins 32Mo de mémoire. Si vous pensez avoir plus de %d Mo de mémoire physique, vérifiez que SmartDrive (SMARTDRV.EXE) n'est pas activé. La mémoire allouée à SmartDrive n'est pas utilisable par les applications.\n\nAppuyez sur 'OK' pour continuer sans la mémoire minimum requise. \n",
		"Pas assez de RAM",
		"Vous n'avez que %d Mo de mémoire disponible.\n\n FreeSpace nécessite au moins 32Mo de mémoire. Si vous pensez avoir plus de %d Mo de mémoire physique, vérifiez que SmartDrive (SMARTDRV.EXE) n'est pas activé. La mémoire allouée à SmartDrive n'est pas utilisable par les applications.\n",
		"FreeSpace nécessite de la mémoire virtuelle.\r\n",
		"Pas de mémoire virtuelle",
		"Pas assez de mémoire pour exécuter Freespace.\r\nEssayez de fermer d'autres applications.\r\n",
		"Pas assez de mémoire",
		"Cette option n'est disponible que dans la version en vente.",
		"%d:",
		"(fr)FreeSpace CD not found\n\nInsert a FreeSpace CD to continue",
		"Séquence vidéo non trouvée.\n\nInsérez le CD FreeSpace n¬∞%d pour continuer",
		"Impossible d'activer la séquence video %s.",
		"Conflit!",
		"Annulé",
		"Vous ne pouvez pas utiliser cette touche. Veuillez réessayer.",
		"?",
		"Touche conflictuelle :",
		"Suite...",
		"Aucune",
		", ",
		"La musique évènementielle n'est pas activée",
		"bande son : %s [%s]",
		"x%.1f",
		"x%.0f",
		"message",
		"dégâts",
		"%d%%",
		"Intégrité coque",
		"<aucun>",
		"K.O.",
		"vict.:",
		"secours",
		"annulé",
		"terminé",
		"réparation",
		"réarmement",
		"obstacle",
		"en transit",
		"occupé",
		"arrivee:",
		"réacteur subsp.",
		"activé",
		"chargement ",
		"des nouveaux ordres",
		"objectif principal",
		"objectif secondaire",
		"objectif de bonus",
		"non rempli (%d/%d)",
		"rempli (%d/%d)",
		"non rempli",
		"[voix rejetée]",
		"[enreg. voix]",
		"[voix diffusée]",
		"2000 m",
		"10,000 m",
		"infini",
		"Repères de tir",
		"Orientation de la cible",
		"Assaillant le plus proche",
		"Direction de la cible",
		"Temps de mission écoulé",
		"Réticule",
		"Accélération",
		"Radar",
		"Surveillance de la Cible",
		"Lunette",
		"Autres Infos sur la Cible",
		"Bouclier de la cible",
		"Bouclier du joueur ",
		"Gestion de l'énergie",
		"Ciblage automatique",
		"Réglage auto. de la vitesse",
		"Arsenal",
		"Moniteur",
		"Directives",
		"Indicateur de menace",
		"Energie post-combustion",
		"Réserve d'énergie",
		"Connexion d'armes",
		"Cible : coque/boucliers",
		"Cible hors écran ",
		"Message vidéo",
		"Affichage des dégâts",
		"Communications",
		"Repérage de la Cible",
		"Mécanismes de défense",
		"Angle d'allongement",
		"Statut des ailiers",
		"Cible hors écran",
		"Vaisseaux Détruits",
		"Assaillants",
		"D",
		"surveillance",
		"Vue escorte activée",
		"Vue escorte désactivée ",
		"Liste d'escorte complète (%d vaisseaux)",
		"Temps actuel",
		"V: ",
		"C: ",
		"0",
		"Vaisseaux",
		"Escadrilles",
		"Tous les chasseurs",
		"Renforts",
		"Réarmement-Réparation",
		"Annuler réarmement",
		"Détruisez ma cible ",
		"Neutralisez ma cible ",
		"Désarmez ma cible ",
		"Détruisez le sous-système ",
		"Protégez ma cible ",
		"Ignorez ma cible ",
		"En formation sur mon aile ",
		"Couvrez-moi ",
		"Attaquez l'ennemi ",
		"Capturez ma cible",
		"Réarmez-moi",
		"Annulez le réarmement",
		"Partez ",
		"[pght]",
		"[pgbs]",
		"Invalide",
		"Not allowed to message",
		"Quel message ?",
		"Quel vaisseau ?",
		"Quelle aile ?",
		"Vaisseau / Aile ?",
		"(*)",
		"Quel ordre ?",
		"Aucune cible",
		"Ciblage du sous-système %s.",
		"Ciblage du sous-système désactivé",
		"Système de cible désactivé",
		"%d%%",
		"cm.",
		"arsenal",
		"<aucun>",
		"Acquisition auto. de cible désactivée (détecteurs endommagés)",
		"Messagerie limitée (système de communication endommagé)",
		"Aucun vaisseau de secours à proximité.  Appelez-en un.",
		"communication",
		"comm",
		"navigation",
		"nav",
		"pas d'odres",
		"temps : ",
		"amarrage: %s",
		"d: %.0f",
		"%d%%",
		"NEUTRALISE",
		"DESACTIVE",
		"NTR",
		"ok",
		"dgt",
		"crt",
		"débris",
		"inconnu",
		"d: %.0f%s",
		"v: %.0f%s",
		"ailiers",
		"(fr)Exit FreeSpace",
		"(fr)Barracks - Manage your FreeSpace pilots",
		"Salle de départ - Commencer ou continuer une campagne",
		"(fr)Tech room - View specifications of FreeSpace ships and weaponry",
		"(fr)Options - Change your FreeSpace options",
		"(fr)Campaign Room - View all available campaigns",
		"Multijoueur - Lancer ou joindre une partie multijoueur",
		"Vous n'avez pas défini le type de connexion Internet. Lancez le programme d'installation, sélectionnez l'option Installation puis l'onglet Réseau pour choisir le type de connexion.",
		"Winsock n'est pas installé. Il vous faut TCP/IP et Winsock pour jouer à FreeSpace en mode multijoueur.",
		"(fr)You have selected TCP/IP for multiplayer Freespace, but the TCP/IP protocol was not detected on your machine.",
		"Vous avez sélectionné la Connexion via modem pour vous connecter à l'Internet. Vous n'êtes pas connecté pour l'instant. Connectez-vous à votre prestataire de service Internet avant d'aller plus loin. ",
		"Vous avez indiqué que vous utilisez une connexion LAN pour les parties en réseau. On dirait que vous êtes connecté à votre prestataire de service Internet. Veuillez vous déconnecter, ou choisissez ",
		"Quitter le jeu ?",
		"Les pilotes multijoueurs n'ont pas accès à la salle de campagne",
		"Pilote mutlijoueur non valide !",
		"'Charger mission' invalide pour pilotes multijoueurs",
		"Démarrage rapide invalide pour pilotes multijoueurs ",
		"Niveau de difficulté: %s.",
		"Appuyez sur F1 pour afficher l'aide",
		"Vous ne pouvez pas changer le niveau de difficulté au milieu d'une mission.",
		"Vous ne pouvez pas changer le niveau de difficulté ici. Seul l'organisateur de la partie peut en décider.",
		"Quitter le jeu ?",
		"Un observateur ne peut utiliser la configuration du cockpit !",
		"Mode un seul joueur",
		"Mode multijoueur",
		"Vous devez d'abord choisir un pilote valide",
		"Vous avez atteint le nombre maximum de pilotes !",
		"Erreur de création d'un nouveau fichier Pilote ! ",
		"(fr)Type Callsign and Press Enter",
		"Attention !\n\nEtes-vous sûr de vouloir effacer ce pilote ? ",
		"Etes-vous sûr de vouloir effacer ce pilote ? ",
		"Conflit : FreeSpace - The Great War, Copyright c 1998, Volition, Inc.",
		"(fr)Copyright %c 1999, Volition, Inc.  All rights reserved.",
		"Adresse invalide !",
		"Annuler",
		"Vérification de l'adresse ip...",
		"Nombre d'adresses IP max. atteint !",
		"Erreur de lecture de la voix enregistrée ! Vérifiez votre matériel",
		"Test micro impossible lors d'un jeu multijoueur !",
		"Echec de l'initialisation de DirectSoundCapture. Pour l'initialiser, votre carte son doit être duplex et vos pilotes de carte son doivent prendre en charge DirectSoundCapture",
		"Saturation de paquets",
		"Phase %d sur %d",
		"Veuillez revoir vos objectifs pour cette mission.",
		"Principal",
		"Secondaire",
		"Bonus",
		"*Objectifs principaux",
		"*Objectifs secondaires",
		"*Objectifs de bonus",
		"Vaisseaux alliés",
		"Vaisseaux ennemis",
		"Détruit",
		"  par : ",
		"Arrivé",
		"Arrivé (vague %d)",
		"Parti",
		"a accosté ",
		"Sous-système ",
		" détruit",
		"Parti avec ",
		"Désactivé",
		"Neutralisé",
		" à demandé à être réarmé",
		" a abandonné le réarmement",
		"Appelé en renfort",
		"Carg. découverte : ",
		"objectif %s ",
		"rempli.",
		"non rempli.",
		"directives",
		"Echec de la formation",
		"&Assigner une commande",
		"&Annuler la mission",
		"Attention\nAucune touche n'est assignée à cette action.\n",
		"<%s s'est fait expulser>",
		"Fermer",
		"Ignorer l'entrainement\n\n\n\nVoulez-vous vraiment ignorer cette mission d'entraînement?",
		"Il n'y a pas de briefing pour la mission : %s",
		"astéroïde",
		"n¬úud subspatial",
		"inconnu",
		" classe",
		"Médaille",
		"Grade",
		"Insigne",
		"(O)",
		"Votre carrière est terminée, traître ! Vous ne pouvez entreprendre de nouvelles missions !",
		"Quel tricheur ! Vous ne pouvez valider cette mission !",
		"Vous avez échoué à cette mission et ne pouvez continuer. Que voulez-vous faire ? ",
		"Retour au debriefing",
		"Aller sur le pont",
		"Rejouer",
		"%d sur %d",
		"Durée de mission",
		"Victoires par type de vaisseau",
		"Nb total de victoires par type de vaisseau",
		"(Aucune victoire lors de cette mission)",
		"(Aucun vaisseau détruit)",
		"&Rejouer",
		"Si vous recommencez cette mission, vous ",
		"Excellente performance. Nous n'avons aucun conseil à vous donner.",
		"&Oui",
		"&Non, réessayer plus tard",
		"Accepter l'issue de cette mission ?",
		"Cette mission s'est soldée par un échec, et vous devrez la reprendre lorsque vous poursuivrez la campagne.\n\nRetour sur le pont ?",
		"Pas de compte-rendu pour la mission: %s",
		"Suite",
		"Choisissez au moins un vaisseau avant de passer à la sélection des armes.",
		"Le vaisseau du joueur n'a pas d'armes ",
		"Le joueur %s doit choisir une place dans la formation",
		"Un %s ne peut transporter de %s.",
		"Phase %d sur %d",
		"Trop près de la planète. Attention aux dégâts !",
		"Transit annulé.",
		"2k",
		"10k",
		"Très facile",
		"Facile",
		"Moyen",
		"Difficile",
		"Dingue",
		"attaquer ",
		"amarrer ",
		"points de passage",
		"détruire ",
		"formation ",
		"partir",
		"garder",
		"désactiver ",
		"neutraliser",
		"éviter ",
		"réarmer ",
		"Plus de charges de contre-mesures.",
		"Explosion de %s!",
		"Cible trop éloignée pour verrouillage ",
		"Impossible de lancer %s sans verrouillage",
		"%s impossible à lancer (dégâts au système d'armement)",
		"Ce vaisseau n'a pas d'arme principale",
		"Ce vaisseau n'a qu'une arme principale : %s",
		"Ce vaisseau n'a pas d'arme secondaire",
		"Ce vaisseau n'a qu'une arme secondaire : %s",
		" Aile",
		"pas d'ordres",
		"atq %s %s",
		"Inconnu",
		"Noeud subspatial activé.",
		"Votre sous-système (%s) a été détruit.",
		"",
		"",
		"",
		"&OK",
		"&Annuler",
		"&Oui",
		"&Non",
		"Cibler vaisseau suivant",
		"Cibler vaisseau précédent",
		"Cibler assaillant le plus proche",
		"Cibler assaillant le plus proche précédent",
		"Acquisition automatique de cible",
		"Cibler allié le plus proche suivant",
		"Cibler allié le plus proche précédent",
		"Cibler le vaisseau dans le collimateur",
		"Cibler assaillant de la cible le plus proche",
		"Cibler l'auteur de la dernière transmission",
		"Désactiver ciblage sur vaisseau",
		"Cibler le sous-système dans le collimateur",
		"Cibler le sous-système suivant",
		"Cibler le sous-système précédent",
		"Désactiver ciblage sur sous-système",
		"Réglage de la vitesse automatique",
		"Activer/Désactiver la vitesse automatique",
		"Tir de l'arme principale",
		"Tir de l'arme secondaire",
		"Cycle avant arme principale",
		"Cycle arrière arme principale",
		"Cycle arme secondaire",
		"Cycle débit de tir (arme secondaire)",
		"Lancer des mécanismes de défense",
		"Marche avant",
		"Marche arrière",
		"Virage incliné vers la gauche",
		"Virage incliné vers la droite",
		"Tangage en avant",
		"Tangage en arrière",
		"Tourner à gauche",
		"Tourner à droite",
		"Décélération maximale",
		"Accélération maximale",
		"Accélération partielle (1/3)",
		"Accélération partielle (2/3)",
		"Décélération de 5 %",
		"Accélération de 5 %",
		"Attaquez ma cible",
		"Désarmez ma cible",
		"Neutralisez ma cible",
		"Attaquer les sous-systemes de ma cible",
		"Capturez ma cible",
		"Attaquez l'ennemi",
		"En formation sur mon aile",
		"Ignorez ma cible",
		"Protégez ma cible",
		"Couvrez-moi",
		"Retour à la base",
		"Réarmez-moi",
		"Cibler votre assaillant le plus proche",
		"Vue de dos",
		"External View",
		"Verrouiller caméra externe",
		"Caméra libre",
		"Vue de la cible actuelle",
		"Zoom avant",
		"Zoom arrière",
		"Centrer la vue",
		"Regarder vers le haut ",
		"Regarder derrière",
		"Regarder à gauche",
		"Regarder à droite",
		"Portée du radar",
		"Affichage des messages aux ailiers",
		"Show Objectives",
		"Transiter (Fin de Mission)",
		"Cibler la cible de la cible",
		"Post-combustion",
		"Accroître l'énergie des armes",
		"Décroître l'énergie des armes",
		"Accroître l'énergie des boucliers",
		"Décroître l'énergie des boucliers",
		"Accroître l'énergie des réacteurs",
		"Décroître l'énergie des réacteurs",
		"Equilibrer les sytèmes d'énergie",
		"Equilibrer les boucliers",
		"Accroître l'énergie des boucliers avant",
		"Accroître l'énergie des boucliers arrière",
		"Accroître l'énergie des boucliers de gauche",
		"Accroître l'énergie des boucliers de droite",
		"Transfert d'énergie du laser au bouclier",
		"Transfert d'énergie du bouclier au laser",
		"Show Damage Popup Window",
		"Position inclinée",
		"Show NavMap",
		"Ajouter/Supprimer escorte",
		"Supprimer Liste d'escorte",
		"Cibler vaisseau d'escorte suivant",
		"Cibler le vaisseau de secours le plus proche",
		"Cibler le cargo non scanné suivant",
		"Cibler le cargo non scanné précédent",
		"Cibler le vaisseau arrivant dans le secteur",
		"Cibler tourelle active suivante",
		"Cibler tourelle active précédente",
		"(fr)Target Next Hostile Bomb or Bomber",
		"(fr)Target Previous Hostile Bomb or Bomber",
		"(Multijoueur) Message à tous",
		"(Multijoueur) Message aux alliés",
		"(Multijoueur) Message aux ennemis",
		"(Multijoueur) Message à la cible",
		"(Multijoueur) Zoomer sur la cible pour observer",
		"Accroître temps de compression",
		"Décroître temps de compression",
		"",
		"",
		"",
		"",
		"",
		"",
		"",
		"",
		"",
		"Textures canal Alpha",
		"Caractéristiques Manquantes ",
		"Textures 16-bpp RGB",
		"Votre carte vidéo n'offre pas les critères requis par FreeSpace suivants:\r\n\r\n",
		"Fondus d'effets spéciaux",
		"Mode fondu de source",
		"Destination blending mode = INVSRCALPHA ou BOTHINVSRCALPHA\r\n",
		"Au moins 1 Mo de mémoire vidéo disponible requise.",
		"> 1 sec",
		"%d ms",
		"V: ",
		"C:",
		"Noeud %d",
		"%s ne peut pas transporter %s armes",
		"Commande non reconnue",
		"** CTCP Message de %s (%s)",
		"** %s a rejoint %s",
		"*** %s a expulsé %s de %s (%s)",
		"*** %s est maintenant connu en tant que %s",
		"**Erreur: %s n'est pas online!",
		"Votre surnom contient des caractères invalides.",
		"Annuler",
		"Contact perdu avec le serveur. Simulation interrompue jusqu'à ca que le contact soit rétabli. Appuyez sur Annuler pour quitter le jeu.",
		"La Campagne est terminée. Merci.",
		"Campagne vaisseau/arsenal\n",
		"&Annuler",
		"En attente que les clients se déconnectent",
		"Si vous quittez maintenant la partie sera finie pour tous joueurs!",
		"Voulez-vous vraiment quitter ?",
		"<Les capitaines d'équipe sont partis.>",
		"<L'hôte a mis fin à la partie.>",
		"Vous avez été expulsé.",
		"L'hôte a quitté la partie.",
		"L'hôte a refusé votre fichier de mission.",
		"La partie a été interrompue pendant que vous la rejoigniez.",
		"Votre sélection d'un vaisseau a été trop longue.",
		"Le contact avec le serveur a été perdu.",
		"Echec de la connexion avec le serveur.",
		"Echec du chargement du fichier de la mission.",
		"Création d'un vaisseau pour joueur rejoignant la partie impossible.",
		"Bogues reçues lorsque le(s) joueur(s) ont rejoint la partie",
		"Echec du transfert au serveur",
		"Le serveur se heurta à des erreurs lors de la distribution des vaisseaux aux joueurs",
		"L'hôte a quitté le jeu. Annulation...",
		"Le(s) capitaine(s) d'équipe ont quitté le jeu. Annulation...",
		"Erreur lors de la réception du fichier de la mission!",
		"Attention ! Echec du lancement de Parallax Online. Les données des jeux précédents ne seront pas disponibles !",
		"&Annuler",
		"essai de validation du pilote...",
		"&Ok",
		"Pilote refusé par Parallax Online !",
		"Nouveau pilote créa et validé !",
		"Pilote Parallax Online validé !",
		"&Quitter",
		"&Réessayer",
		"Temps de validation écoulé",
		"Envoi des résultats des joueurs...",
		"Classification des résultats Parallax Online réussie !",
		"Echec de la classification des résultats Parallax Online !",
		"Tentative de réception des résultats des pilotes...",
		"Réception des résultats pour %s...\n",
		"Actualisation des résultats pour %s...\n",
		"Temps restant : %ds\n",
		"Infos sur les vaisseaux\n",
		"Infos sur les escadrilles\n",
		"Infos sur le nombre de vies\n",
		"On vous a refusé le vaisseau désiré.",
		"<%s a été expulsé>",
		"Vaisseau observateur ",
		"Image Invalide ",
		"En attente",
		"Transfert de l'image",
		"Aucune Image",
		"Aucun vol",
		"TOUS : ",
		"ALLIE :",
		"ENNEMI : ",
		"CIBLE : ",
		"<SERVEUR>",
		"ORDRE DE <%s> :",
		"Attaquer %s",
		"Neutraliser %s",
		"Protéger %s",
		"Ignorer %s",
		"Désarmer %s",
		"Neutraliser sous-système %s  (%s)",
		"Formation sur mon aile",
		"Couvrez-moi",
		"Attaquer l'ennemi!",
		"Transfert Serveur",
		"jeu de \n",
		"Transfert Serveur réussi !",
		"<%s prend la parole>",
		"&Ok",
		"Une copie de ce fichier existe déjà mais ne peut être écrasée par le serveur car ce fichier est est un Texte-seulement. Change l'autorisation.",
		"Le joueur %s a essayé de joindre. Accepter o/n ?",
		"%s a rejoint le jeu\n",
		"<%s a rejoint le jeu>",
		"<%s a été expulsé>",
		"%s a quitté le jeu.",
		"Démarrage de la mission reçu\n",
		"Données du joueur reçues\n",
		"Votre accès a été refusé car le jeu n'est pas en mesure de vous accepter.",
		"Vous avez été refusé car il s'agit d'une partie Parallax Online et vous n'êtes pas un pilote enregistré sous Parallax Online.",
		"L'accès à cette partie nécessite un mot de passe.",
		"Votre accès a été refusé car cette partie est fermée et la mission en cours.",
		"Vous avez été refusé car la partie est en train d'être créée et l'hôte l'a temporairemnt fermée.",
		"Vous avez été refusé car cette partie exclut certains grades et le votre est trop élevé.",
		"Vous avez été refusé car cette partie exclut certains grades et le votre est trop petit.",
		"Vous avez été refusé car un pilote identique au vôtre existe déjà pour cette partie.",
		"Vous avez été refusé car la partie est au complet.",
		"Vous avez été refusé car vous avez étébanni par ce serveur.",
		"Vous avez été refusé car n'accepte pas d'observateurs.",
		"Quelqu'un est en train de rejoindre le jeu. Réessayez dans quelques minutes.",
		"Vous ne pouvez rejoindre cette partie car votre version de FreeSpace n'est pas assez récente. Quittez FreeSpace et sélectionnez 'Actualisation'.",
		"Armes \n",
		"Le joueur %s a essayé de rejoindre la partie. L'accepter o/n ?",
		"C",
		"IA",
		"Classe",
		"Type",
		"Longueur",
		"Vitesse maximale",
		"%d m/s",
		"Maniabilité",
		"Blindage",
		"Canons",
		"Rangées de Missiles",
		"",
		"Vaisseaux/Armes verrouillés",
		"Vaisseaux/Armes disponibles",
		"Les joueurs n'ont pas encore été assignés à leur vaisseau.",
		"Il vous encore des vaisseaux à assigner.",
		"Certains vaisseaux n'ont pas d'armes principales !",
		"Certains vaisseaux n'ont pas d'armes secondaires !",
		"suite",
		" Erreur de réseau. Quittez et relancez FreeSpace pour supprimer l'erreur.  Ou redémarrez votre ordinateur.",
		"Aucun jeu trouvé !",
		"Aucun jeu sélectionné !",
		"Attente de la demande d'accès précédente !",
		"Toujours pas établi !",
		"> 1 sec",
		" ms",
		"<Aucun serveur trouvé>",
		"Form",
		"Briefing",
		"Debriefing",
		"Pause",
		"En cours",
		"Inconnu",
		"Accepté. Attente des données du joueur.",
		"Temps de demande d'accès écoulé!",
		"Le mode équipe contre équipe interdit l'accès à une partie en cours",
		"Envoi de la demande d'accès en cours...",
		"Serveurs sur canal : %s",
		"Attention - Avec une actualisation des objets basse, le serveur ne peut acceuillir plus d'un client",
		"Actualisation des objets basse,  ~2000 octets/sec. Appropiée pour des clients avec modems 28.8, mais pas recommandée pour",
		"Attention - Avec une actualisation des objets moyenne, le serveur ne peut acceuillir plus d'un ou deux clients.",
		"Actualisation à ~4000 bytes/second, appropriée pour des clients avec modems 56.6, mais pas recommandée pour",
		"&Annuler",
		"&Continuer",
		"&Plus d'infos",
		"Jeu de %s",
		"Nom provisoire",
		"Valeur invalide pour un hôte avec un grade comme le vôtre (%s)\n",
		"lieutenant",
		"Lt.",
		"(O)",
		"Attendez svp que tous les clients aient rejoint la partie.",
		"Aucune mission sélectionnée !",
		"Aucune campagne sélectionnée!",
		"Il y a trop d'observateurs\n\nMax : %d\nActuellement %d\n\nJetez-en quelques-uns",
		"Il y a trop d'observateurs \n\nMax : %d\nActuellement %d\n\nJetez-en quelques-uns",
		"Les équipes et/ou leurs capitaines n'ont pas été distribués correctement.",
		"Vous avez besoin d'1 CD tous les 4 joueurs!",
		"NA",
		"Attention\nLe nombre de vies est supérieur à la limite autorisée (%d)",
		"Attention \nLa durée de mission est supérieure à la limite autorisée (%d)",
		"Attention \nLe nombre d'observateurs est supérieur à la limite autorisée (%d)",
		"Attention \nLe nombre de victimes est supérieur à la limite autorisée (%d)",
		"Attention \nLe délai de transmission vocale est supérieur à la limite autorisée (%d)",
		"Lancer",
		"Chargement de la mission en cours",
		"Sélectionner vaisseau de l'interface",
		"Compte-rendu",
		"Sync Mission ",
		"rejoint la partie",
		"a rejoint la partie",
		"confirmer",
		"Sélectionner Vaisseau ",
		"Sélectionner Arme",
		"En attente",
		"Mission en cours",
		"Mission Chargée",
		"Chargement des données",
		"Prêt au lancement de la mission",
		"Infos sur les vaisseaux durant la mission ",
		"Infos sur les escadrilles durant la mission ",
		"Points de vies durant la mission",
		"Armes durant la mission",
		"Données Post Compte-rendu",
		"Drapeaux",
		"Actualisation résultats Parallax Online",
		"Armes",
		"Configuration de l'hôte",
		"Accepter Debrief",
		"Refaire Debrief",
		"Campagne vaisseau/armement",
		"Transfert fichier Mission %d%%",
		"Transfert fichier Mission ",
		"Serveur effectuant sync\n",
		"Envoyer actualisation\n",
		"signatures reçues\n",
		"Envoi de l'actualisation\n",
		"Envoi demande infos de fichier\n",
		"Envoi des données\n",
		"mission chargée localement\n",
		"Vers la sélection des équipes\n",
		"Client effectuant sync\n",
		"Envoi des infos post briefing\n",
		"Envoi des infos relatives à l'arsenal\n",
		"Envoi des infos relatives à la config du joueur\n",
		"Vers la partie\n",
		"Envoi des infos relatives aux résultats de mission\n",
		"&Accepter",
		"&Jeter",
		"(Continuer Jeu via le Net)\nAcceptez-vous ces résultats ?",
		"(Sortir du Jeu via le Net)\nAcceptez-vous ces résultats ?",
		"&Sortir",
		"Voulez-vous vraiment sortir avant la classification des résultats ?",
		"<résultats acceptés>",
		"<résultats jetés>",
		"aucun autre joueur par réseau",
		"tué",
		"tué",
		"tué",
		"tué",
		"tué",
		"assassiné",
		"tué",
		"détruit",
		"démoli",
		"tué",
		"tué",
		"rôti",
		"massacré",
		"tué comme un cochon",
		"décimé",
		"abattu",
		"abattu",
		"assassiné",
		"",
		"tué",
		"tué",
		"tué",
		"tué",
		"tué",
		"tué",
		"tué",
		"rôti ",
		"tué",
		"tué",
		"tué",
		"tué",
		"tué",
		"tué",
		"tué",
		"tué",
		"tué",
		"tué",
		"tué",
		"tué",
		"tué",
		"dit",
		"dit",
		"s'exclame",
		"déclare",
		"déclare",
		"déclare",
		"gémit",
		"déclare",
		"<%s est parti>",
		"Larguage de %s après une oisivité prolongée",
		"[adresse ipx ici]",
		"Vaisseau seul",
		"résultats recueilli en %7.3f secondes\n",
		"Indicatif\tOctets lus/s\tOctets écrit/s\n",
		"Impossible de trouver les résultats de réseau pour %s...interruption\n",
		"-------------------------\nTotal:\t%d\t%d\n",
		"\n\nStatistiques\n---------------\nPaquet #\tNombre de paquets envoyés\tTotal d'octets\t%% en tout\n",
		"[aucun réseau]",
		"# Connexions : ",
		"Hôte connecté ? Oui",
		"Hôte connecté ? Non",
		"> 1 sec",
		" ms",
		"",
		"Objectifs Primaires",
		"Objectifs Secondaires",
		"Objectifs de Bonus",
		"aucun",
		"Vue Arbre ",
		"Echec de l'ouverture de session du serveur autonome à Parallax Online!",
		"Parallax Online !",
		"<SERVEUR> %s",
		"ok",
		"annuler",
		"&appliquer",
		"Aide",
		"Arrêter",
		"Connexions",
		"Multi-Joueur",
		"Infos Joueur",
		"trucs",
		"Dépannage",
		"Freespace Autonome",
		"&Créer Cmpt",
		"&Vérifier Cmpt",
		"PXO Login non accepté. vous pouvez vous rendre sur le site web de Parallax Online pour créer ou vérifier une session, ou cliquer sur Annuler pour jouer sans l'intermédiaire de Parallax Online.",
		"recherche des canaux publics",
		"connexion à Parallax Online échouée",
		"Vous avez été expulsé.",
		"Vous avez été déconnecté.",
		"Attention\nImpossible de localiser/lancer l'Internet.",
		"Aucun canal !",
		"Déjà en train d'essayer de rejoindre un canal !",
		"Impossible d'obtenir les résultats pour %s\n(ce pilote n'est peut-être pas enregistré)",
		"Connexion à Parallax Online échouée !",
		"Annuler",
		"Connexion à Parallax Online",
		"*** %s est parti",
		"Connexion à Parallax Online",
		"Rafraîchissement de la liste des canaux publics",
		"Commutation des canaux",
		"Aucun canal (erreur durant commutation)",
		"%s sur %s",
		"Parallax Online - Aucun canal",
		"message privé de",
		"message privé de",
		"privé message pour",
		"privé message pour",
		"Entrez le nom du canal à rejoindre/créer ",
		"Entrez le nom de l'utilisateur à trouver",
		"Recherche de %s",
		"Utilisateur non trouvé",
		"Joueur connecté mais pas sur ce canal",
		"%s Trouvé sur :",
		"%s Trouvé sur un canal privé",
		"Réception des résultats du joueur",
		"Obtention de l'identité du joueur",
		"Aucun vol",
		"DirectSound n'a pu être initialisé. Fermez tout programme utilisant des fichiers son.",
		"Microsoft ADPCM codec n'a pu être initialisé.\n\nveuillez consulter le fichier Lisez-moi pour plus de renseignements.",
		"Echec de la connexion au site web",
		"Site web introuvable",
		"Echec de l'envoi des données au site web",
		"Echec de la création d'un fichier de version",
		"Echec de la réception des données du site web",
		"Une erreur s'est produite lors de la vérification de votre version de FreeSpace. Si vous continuez, l'actualisation n'aura pas forcément lieu.",
		"Erreur à l'ouverture du fichier des données de version",
		"Une nouvelle version de Freespace est disponible. Vous aurez besoin des dernières\n\nmodifications pour jouer sur PXO. Procéder à l'actualisation ?",
		"Vérification de la version de Freespace",
		"Jonction au dernier canal (",
		"Impossible de joindre dernier canal",
		"Jonction automatique au canal public",
		"Impossible de rejoindre canal public",
		"Vous devez définir votre vitesse de connexion : à partir du programme de lancement, sélectionnez le bouton 'Configuration' puis l'onglet 'Réseau'.",
		"Une erreur s'est produite lors de l'analyse du fichier de mission. Ce fichier contient des donn¬Çes interdites.",
		"Impossible de copier freespace.exe à partir du répertoire de mise à jour vers le répertoire d'installation. Copiez le fichier freespace.exe à partir du répertoire de mise à jour (situé dans le répertoire d'installation de Freespace) vers votre répertoire d'installation.",
		"Mission simple\n\n%s",
		"Campagne\n\n%s",
		"Chargement des missions",
		"Chargement de la campagne",
		"Vous ne pouvez pas joindre ce jeu car vous n'utilisez pas le Disque des Missions Freespace",
		"Vous avez sélectionné une mission ou une campagne avec le Disque des Missions alors que les autres joueurs ne disposent pas de ce disque",
		"&Retour",
		"Vous avez choisi une mission qui est soit inaccessible soit inconnue de PXO. Vos résultats ne seront pas sauvegardés si vous continuez",
		"Attention\n\nSi vous lancez une mission PXO par vous-même, vos résultats ne seront pas actualisés",
		"L'accès vous a été refusé car le transfert de mission a échoué.",
		"L'accès vous a été refusé car vous n'avez pas la mission de base.",
		"L'accès vous a été refusé car vous avez voulu vous joindre à une partie déjà terminée",
		"<Stockage des résultats PXO terminé>",
		"<Echec du stockage des résultats PXO du joueur %s>",
		"<%s a été débouté à cause d'un échec de transfert du fichier de mission>",
		"<%s a été débouté car il n'a pas les missions de base %s>",
		"<%s a été débouté car il a tenté de se joindre à une partie déjà terminée>",
		"Attention\n\nCe pilote a participé à des parties PXO. Si vous continuez et jouez à une partie non-PXO, vos résultats ne seront pas sauvegardés",
		"Grade",
		"Vols",
		"Dur\x82",
		"Dernier vol",
		"Victimes",
		"Tirs de l'arme principale",
		"Tirs principaux r\x82ussis",
		"Tirs de l'arme secondaire",
		"Tirs secondaires r\x82ussis",
		"Mouvement de lacet avec le joystick",
		"Tangage avec le joystick",
		"Virage incline avec le joystick",
		"Acceleration Maximale Avec Le Joystick",
		"Acceleration Relative Avec Le Joystick",
		"Axe X Joystick/Souris",
		"Axe Y Joystick/Souris",
		"Axe Z Joystick",
		"Axe rX Joystick",
		"Axe rY Joystick",
		"Axe rZ Joystick",
		"Bouton Gauche",
		"Bouton Droite",
		"Bouton Milieu",
		"G/D",
		"H/D",
		"N",
		"O",
		"(fr)Create",
		"(fr)Accept",
		"(fr)Options",
		"(fr)Medals",
		"(fr)Remove",
		"(fr)Select",
		"(fr)Clone",
		"(fr)Single",
		"(fr)Multi",
		"(fr)Convert",
		"(fr)<Server detected a hacked ships.tbl. Stats will not be saved>",
		"(fr)You are playing with a hacked ships.tbl, your stats will not be saved",
		"(fr)<Server detected a hacked weapons.tbl. Stats will not be saved>",
		"(fr)You are playing with a hacked weapons.tbl, your stats will not be saved",
		"(fr)<Not enough players were present at game start or end, stats will not be saved>",
		"(fr)<Server detected a non PXO validated mission. Stats will not be saved>",
		"(fr)This is not a PXO validated mission, your stats will not be saved",
		"(fr)You or the server you are playing on has a hacked ships.tbl. Your stats will not be updated on PXO",
		"(fr)You or the server you are playing on has a hacked weapons.tbl. Your stats will not be updated on PXO",
		"(fr)No/Invalid Image",
		"(fr)We have no recommendations for you.",
		"(fr)Technical Database",
		"(fr)Mission Simulator",
		"(fr)Cutscenes",
		"(fr)Credits",
		"(fr)Exit",
		"(fr)Single Missions",
		"(fr)Campaign Missions",
		"(fr)Commit",
		"(fr)Mission",
		"(fr)Filename",
		"(fr)Weapons",
		"(fr)Intelligence",
		"(fr)Ship Selection",
		"(fr)Weapon Loadout",
		"(fr)Continue",
		"(fr)Events",
		"(fr)Objectives",
		"(fr)Messages",
		"(fr)You need to have at least %d players per squad for Squad War",
		"(fr)Validating mission %s",
		"(fr)Validating squad war",
		"(fr)Please enter the match code",
		"(fr)Squad war match does not check out. Please make sure the code you entered was correct and all players are valid members of their respective squads",
		"(fr)Storing squad war results",
		"(fr)<Squad war results stored on PXO>",
		"(fr)<Squad war results rejected by PXO>",
		"(fr)%s was killed by a beam weapon",
		"(fr)%s was destroyed by a beam from %s",
		"(fr)No 3D acceleration",
		"(fr)Video",
		"(fr)Currently Selected Video Mode:",
		"(fr)A 3D accelerated video card must be selected in order to run Freespace.  Select your desired renderer from the above drop-down list.",
		"(fr)Detect Available Cards",
		"(fr)Options:",
		"(fr)Interlaced cutscenes",
		"(fr)Fast clear for cutscenes",
		"(fr)Fast Direct3D textures (lower visual quality)",
		"(fr)Freespace requires Glide or Direct3D hardware accleration. You will not be able to run Freespace without it",
		"(fr)Warning",
		"(fr)Up to Date",
		"(fr)Update Required",
		"(fr)Need to Install",
		"(fr)Windows NT has DirectX built in.  If you are running NT 4.0 you should have Service Pack 3 (SP3) or later installed.  For detailed information on NT Service Packs (including download links), go to:\n%s.\n\nDo you want to go to this link?",
		"(fr)Your version of DirectX is less than 5.0.  It is recommended that you install DirectX 5.0 on your system.\n\nDo you want to install DirectX 5.0?\n\n",
		"(fr)Your version of DirectX is up to date.\nFor detailed information on the latest version of DirectX (including download links), go to:\n%s.\n\nDo you want to go to this link?",
		"(fr)DirectX Version Info",
		"(fr)Your DirectX Version",
		"(fr)Your Version Status",
		"(fr)Freespace requires DirectX 3.0 (or greater).  DirectX 6.0 is required for Direct3D, Force Feedback, and Direct Sound 3D.",
		"(fr)Install/Update DirectX",
		"(fr)FreeSpace Launcher",
		"(fr)FreeSpace Demo Launcher",
		"La opérant syst est hors memory ou ressources.",
		"La.EXE fichier est invalide (non-Win32.EXE ou erreur aux.EXE image).",
		"La opérant syst nia accès au spécifia fichier.",
		"La filename association est morcelé ou invalide.\r\n(Te besoin pour ai un default Internet browser emménagea)",
		"La DDE transaction purent non soient compléta car autre DDE transactions furent étanttraité.",
		"La DDE transaction failli.",
		"La DDE transaction purent non soient compléta car la demande timed out.",
		"La spécifia dynamic-link bibliothèque n'était trouva.",
		"Delà n'était enough memory pour complet la opération.",
		"Un partageant violation occurred.",
		"\r\n",
		"Inconnu erreur occurred.",
		"(fr)Warning!",
		"(fr)You must allow Setup to configure your default settings before playing Freespace for the first time.\n\nTo do this, press the 'Setup' button from the main menu and examine each tab.  Then, press the 'OK' button at the bottom.",
		"(fr)No Rendering Device Selected!",
		"(fr)You must allow Setup to configure your Video Card setting before playing Freespace.\n\nTo do this, press the 'Setup' button from the main menu and click on the Video Tab.  Then, press the 'Detect Available Cards' button and choose your video mode.  Finally, press the 'OK' button at the bottom.",
		"(fr)DirectX 3.0 or higher Required!",
		"(fr)You must install DirectX 3.0 or higher to run Freespace.\n\nTo do this, press the 'Setup' button from the main menu and click on the 'DirectX' tab and follow the direction on it.",
		"Erreur Lancement FreeSpace",
		"(fr)Setup",
		"Erreur Lancement README.TXT",
		"Aucun enlever information trouva.",
		"Etes-vous sûr de vouloir supprimer Conflict: FreeSpace et tous ses composants?",
		"Confirmer la supression des fichiers",
		"Erreur Lancement Enleverer",
		"(fr)Welcome to FreeSpace!",
		"(fr)Since this is your first time running FreeSpace, you will now be automatically taken to the Setup window.  \n\nNOTE TO USER:\nIt is important that you view each section of the Setup window and configure it to your liking.  Press the Help button if you have questions about a particular section.  Once you are satisfied with your settings, select the OK button at the bottom of the Setup window to save them.",
		"(fr)Joystick",
		"<Aucun>",
		"(fr)Current Joystick",
		"(fr)Enable Force Feedback",
		"(fr)Enable Directional Hit (Force Feedback)",
		"(fr)Calibrate",
		"(fr)Detect Available Joysticks",
		"FreeSpace CD non localisa.  Plaire encartent FreeSpace CD #1 et sélectionnent OK pour continuent.",
		"(fr)Misc",
		"(fr)Select Language",
		"(fr)Optional Command Line",
		"Ne touvait Enlever",
		"(fr)Network",
		"(fr)Internet Connection",
		"(fr)Connection Speed",
		"(fr)None",
		"(fr)Dialup Networking",
		"(fr)LAN/Direct Connection (and AOL)",
		"(fr)None Specified",
		"(fr)Slower than 56K Modem",
		"(fr)56K Modem",
		"(fr)Single Channel ISDN",
		"(fr)Dual Channel ISDN, Cable Modems",
		"(fr)T1, ADSL, T3, etc.",
		"Erreur lecture CD.",
		"(fr)Speed",
		"Lente",
		"Moyenne",
		"Rapide",
		"Très rapide",
		"(fr)Default Detail Level:",
		"(fr)Properties",
		"(fr)CPU Type:",
		"(fr)CPU Speed:",
		"(fr)Total RAM:",
		"(fr)RAM Transfer Rate:",
		"(fr)VRAM Transfer Rate:",
		"(fr)3D Graphics Accelerator*:",
		"(fr)*Configured in the 'Video' tab.",
		"(fr)Detect",
		"(fr)Audio",
		"Aureal sain carte détecta, mais te besoin actualisa chauffeurs. Download eux dès www.a3d.com",
		"Ce est non-Aureal-certified A3D!\nS'il vous plait upgrade ta chauffeurs chez www.a3d.com",
		"(fr)No Sound",
		"(fr)Currently Selected Sound Card",
		"(fr)Detect Available Sound Cards",
		"(fr)Enable Launcher Sounds",
		"(fr)The Freespace Launcher needs to be updated to a newer version.\nHowever, the replacement executable or patch file could not be accessed.\n\nTherefore, the Launcher cannot be updated at this time.",
		"(fr)The Freespace Launcher needs to be updated to a newer version.\nHowever, the Update Launcher executable could not be found (or could not be accessed).\n\nTherefore, the Launcher cannot be updated at this time.",
		"(fr)The Freespace Launcher needs to be updated to a newer version.\nIt will now be shutdown, modified, and then restarted.\n\nThis may take several seconds...",
		"(fr)Launcher Update",
		"(fr)Error!",
		"(fr)Up to date",
		"(fr)Waiting for User",
		"(fr)Select Patch Download Site",
		"(fr)Patching Failed!!",
		"(fr)Connecting",
		"(fr)Downloading File",
		"(fr)URL redirected",
		"(fr)Download Cancelled",
		"(fr)Sorry, there is no message of the day.",
		"(fr)Unable to continue!!  Press Cancel.",
		"(fr)Unable to continue",
		"(fr)File not Found Error",
		"(fr)File Download HTTP error.  Status code: %d",
		"(fr)Downloading MOTD File",
		"(fr)Downloading Version Info File",
		"(fr)Downloading Sites File",
		"(fr)Unable to read sites from version.nfo",
		"(fr)Downloading Patch File",
		"(fr)Download %d bytes of %d  (%d%%)",
		"(fr)Couldn't parse Version file!",
		"(fr)The Freespace Auto-Update program could not find your current game Version in the system registry.\n\nThis should be corrected by starting up the game, exiting the game, and then running the Auto-Update program.",
		"(fr)Unable to Determine User's Version",
		"(fr)Press OK to download the new version of Freespace!!",
		"(fr)A new version of Freespace is available!!!  Press the OK button to download it.",
		"(fr)Determination: No Update Necessary",
		"(fr)Your Freespace version %d.%02d is currently up to date.",
		"(fr)Patching Error",
		"(fr)Processing %s",
		"(fr)File Complete!",
		"(fr)Searching for systems to update...",
		"(fr)Patching Failed!",
		"(fr)Patch Library not found.",
		"(fr)Patch Library not found.  Cannot Patch Freespace.",
		"(fr)Beginning Patching...",
		"(fr)Patching Complete!",
		"(fr)Error: URL could not be parsed",
		"(fr)Error: Site redirects with no new location",
		"(fr)Insufficient disk space to download file: ",
		"(fr)Error trying to download file",
		"(fr)Error trying to write file",
		"(fr)You must select a download site.",
		"(fr)Site Selection",
		"(fr)You must select a download site.",
		"(fr)Site Name",
		"(fr)URL",
		"(fr)Location",
		"(fr)The site info file could not be opened and parsed.",
		"(fr)Freespace Auto-Update",
		"(fr)Message of the Day:",
		"(fr)Your Version:",
		"(fr)Latest Version:",
		"(fr)Progress:",
		"(fr)Status:",
		"(fr)Patch Download Site Selection",
		"(fr)Select the site you wish to download from:",
		"(fr)Updating the Freespace Launcher...",
		"(fr)Please Wait",
		"(fr)ERROR: This program was executed outside of the Freespace Launcher!",
		"(fr)ERROR: Could not find file:  %s",
		"(fr)ERROR: Could not access file:  %s",
		"(fr)ERROR: Could not delete file:  %s",
		"(fr)ERROR: Could not rename file:  %s",
		"(fr)ERROR: The patch application function could not be obtained from the DLL.",
		"(fr)ERROR: The patch could not be completed successfully.",
		"(fr)Starting up the old Freespace Launcher...",
		"(fr)Starting up the new Freespace Launcher...",
		"(fr)ERROR: The Launcher could not be restarted.",
		"(fr)Freespace Launcher Update Error",
		"(fr)The launcher has not been updated.",
		"(fr)Unassigned",
		"(fr)All",
		"(fr)Coop",
		"(fr)Team",
		"(fr)Dogfight",
		"(fr)Refresh Missions",
		"(fr)Pilot Info",
		"(fr)Missions",
		"(fr)Campaigns",
		"(fr)1",
		"(fr)2",
		"(fr)Kick",
		"(fr)Host Options",
		"(fr)Create Game",
		"(fr)Players",
		"(fr)Lock",
		"(fr)has hacked tables/data",
		"(fr)One or more players has hacked data files. You cannot play a Squad War match unless all clients have legal data",
		"(fr)One or more players has hacked data files. If you continue, stats will not be stored at the end of the mission",
		"(fr)One or more players has hacked data files",
		"(fr)<Team 1 had %d points>",
		"(fr)<Team 2 had %d points>",
		"(fr)<Match was a tie>",
		"(fr)<Team 1 (green) is the winner>",
		"(fr)<Team 2 (red) is the winner>",
		"(fr)Highest rank",
		"(fr)Team / wing-leader",
		"(fr)Any",
		"(fr)Host",
		"(fr)Skill level",
		"(fr)On",
		"(fr)Off",
		"(fr)Host modifies ships",
		"(fr)Respawn Limit",
		"(fr)AI Orders",
		"(fr)End Mission",
		"(fr)Time Limit",
		"(fr)Min",
		"(fr)Kill Limit",
		"(fr)Observers",
		"(fr)Voice Transmission",
		"(fr)Voice Quality",
		"(fr)Message Duration",
		"(fr)Voice Wait",
		"(fr)Refresh",
		"(fr)Join as",
		"(fr)Observer",
		"(fr)Game",
		"(fr)Join",
		"(fr)Status",
		"(fr)Server",
		"(fr)Players",
		"(fr)Ping",
		"(fr)Team 1",
		"(fr)Team 2",
		"(fr)Pilot",
		"(fr)Info",
		"(fr)Choose Team",
		"(fr)Web",
		"(fr)Ranking",
		"(fr)Find",
		"(fr)Motd",
		"(fr)Channel",
		"(fr)Private",
		"(fr)Games",
		"(fr)Squad",
		"(fr)Channels",
		"(fr)Open",
		"(fr)Closed",
		"(fr)Restricted",
		"(fr)Password Protected",
		"(fr)Allow Rank",
		"(fr)Above",
		"(fr)Below",
		"(fr)Start Game",
		"(fr)Title",
		"(fr)Game Type",
		"(fr)Enter Password",
		"(fr)Statistics",
		"(fr)Recommendations",
		"(fr)Play",
		"(fr)Loading",
		"(fr)Reset",
		"(fr)%s was killed by friendly fire from %s",
		"(fr)%s was destroyed by friendly beam fire from %s",
		"(fr)Targeting",
		"(fr)Ship",
		"(fr)Invert",
		"(fr)Undo",
		"(fr)Defaults",
		"(fr)Search",
		"(fr)Bind",
		"(fr)Clear",
		"(fr)Conflict",
		"(fr)All",
		"(fr)Selected",
		"(fr)Detail",
		"(fr)Control",
		"(fr)Config",
		"(fr)HUD",
		"(fr)Preset Detail Levels",
		"(fr)Custom",
		"(fr)Planets/backgrounds",
		"(fr)Target View Rendering",
		"(fr)Weapon Extras",
		"(fr)Model Detail",
		"(fr)Nebula Detail",
		"(fr)3D Hardware Textures",
		"(fr)Particles",
		"(fr)Impact Effects",
		"(fr)Shield Hit Effects",
		"(fr)Stars",
		"(fr)Lighting",
		"(fr)Briefing Voice",
		"(fr)Volume",
		"(fr)Effects",
		"(fr)Music",
		"(fr)Voice",
		"(fr)Mouse",
		"(fr)Sensitivity",
		"(fr)Brightness",
		"(fr)Joystick",
		"(fr)Deadzone",
		"(fr)TCP",
		"(fr)IPX",
		"(fr)IP Address",
		"(fr)add",
		"(fr)rem.",
		"(fr)PXO",
		"(fr)Login",
		"(fr)Password",
		"(fr)Squadron",
		"(fr)Broadcast Locally",
		"(fr)General",
		"(fr)Mic test",
		"(fr)Mute",
		"(fr)Object Update",
		"(fr)Lan",
		"(fr)Pilot / Squad Images",
		"(fr)Yes",
		"(fr)No",
		"(fr)Transfer Missions",
		"(fr)/multidata",
		"(fr)/missions",
		"(fr)Flush Cache",
		"(fr)Never",
		"(fr)Before Game",
		"(fr)You have selected IPX for multiplayer Freespace, but the IPX protocol was not detected on your machine.",
		"(fr)Restart",
		"(fr)Campaign",
		"(fr)Replay",
		"(fr)Incoming Transmission",
		"(fr)complete",
		"(fr)Create",
		"(fr)Select",
		"(fr)Mission",
		"(fr)Misc",
		"(fr)Game",
		"(fr)Clear",
		"(fr)Clear",
		"(fr)Config",
		"(fr)Exit",
		"(fr)Exit",
		"(fr)Exit",
		"(fr)Exit",
		"(fr)Exit",
		"(fr)You have killed yourself with a shockwave from your own weapon",
		"(fr)You have killed yourself with your own missiles",
		"(fr)name",
		"(fr)class",
		"(fr)status",
		"(fr)primary",
		"(fr)secondary",
		"(fr)Blast",
		"(fr)Engine Wash",
		"(fr)Evaded",
		"(fr)Collision",
		"(fr)Replay previous mission",
		"(fr)You cannot join a game in progress unless it is a dogfight mission.",
		"(fr)Barracks",
		"(fr)Pilot Stats",
		"(fr)Choose Pilot",
		"(fr)Complete",
		"(fr)Incomplete",
		"(fr)Failed",
		"(fr)Mission Paused",
		"(fr)Press ESC to return to the game",
		"(fr)Skip Training",
		"(fr)Don't show me this again",
		"(fr)&Next",
		"(fr)You cannot change your squadron in Single Player mode.",
		"(fr)Please configure your system in the Launcher before running FS.\n\n The Launcher will now be started!",
		"(fr)Attention!",
		"(fr)Warning, Freespace requires Glide or Direct3D hardware accleration. You will not be able to run Freespace without it.",
		"(fr)Warning",
		"(fr)The Launcher could not be restarted.",
		"(fr)Error",
		"(fr)Previous Mission",
		"(fr)Popup",
		"(fr)Save",
		"(fr)Amber",
		"(fr)Blue",
		"(fr)Green",
		"(fr)Brightness",
		"(fr)warning flash",
		"(fr)comm menu",
		"(fr)support gauge",
		"(fr)lag gauge",
		"(fr)auto",
		"(fr)speed",
		"(fr)target",
		"(fr)Exit",
		"(fr)Decline",
		"(fr)Please insert CD %d",
		"(fr)more",
		"(fr)You have failed this mission five times.",
		"(fr)If you like, you may advance to the next mission.",
		"(fr)You have failed this mission five times.  If you like, you may advance to the next mission.",
		"(fr)Do Not Skip This Mission",
		"(fr)Advance To The Next Mission",
		"(fr)Don't Show Me This Again",
		"(fr)Self destructed",
		"(fr)Exit Loop",
		"(fr)SquadWar results invalidated",
		"(fr)\r\nUnable to locate Fred Help file: \\data\\freddocs\\index.html\r\n",
		"(fr)DirectDraw could not be initialized on your system.  DirectDraw v6.0 or higher\nis required in order to play FreeSpace.",
		"(fr)Attention!",
		"(fr)Need to run FreeSpace first to set version info.",
		"(fr)Original '%s' contents do not match, update aborted.  Re-installing may be necessary.  \n\n",
		"(fr)If problem persists, please contact Volition Support, support@pxo.net.",
		"(fr)Detect Direct3D",
		"(fr)Detect Glide",
		"(fr)Turret",
		"(fr) subsystem cargo revealed: ",
		"(fr)Exit Loop\n\n\n\nAre you sure you want to leave the mission loop?",
		"(fr)<No Mission Loop Description Available>",
		"(fr)\n\n\nDo you want to play the optional mission?",
		"(fr)OK",
		"(fr)Nothing",
		"(fr)%s was killed by engine wash from %s",
		"(fr)There is a limit of %d ships in the mission at once.  Please be sure that you do not have more than %d ships present in the mission at the same time.",
		"(fr)An error occured while patching the Launcher, 'FreeSpace2.exe'.\nThe remaining files were updated successfully, but your Launcher is still out-of-date.\nWe recommend that you manually download the latest Launcher from our website:\n\n",
		"(fr)\n\nDo you want to want to visit the site now?",
		"(fr)Error Patching the Launcher",
		"(fr)Vertex fog or Table fog\r\n",
		"(fr)Joining netgame",
		"(fr)<kicking %s ...>",
		"(fr)Force WFOG (not recommended)",
		"(fr)Disable Direct3D Zbuffer bias",
		"(fr)Briefing",
		"(fr)Join",
		"(fr)Join",
		"(fr)Launch",
		"(fr)Close",
		"(fr)Skill Level",
		"(fr)Alt",
		"(fr)Shift",
		"(fr)R",
		"(fr)G",
		"(fr)B",
		"(fr)I",
		"(fr)Cancel",
		"(fr)Clear",
		"(fr)Reset",
		"(fr)Help",
		"(fr)Options",
		"(fr)Accept",
		"(fr)sec",
		"(fr)sec",
		"(fr)&Go back",
		"(fr)&Continue",
		"(fr)Mission score",
		"(fr)Score",
		"(fr)Voice",
		"(fr)Sensitivity",
		"(fr)Voice Transmission",
		"(fr)Voice Quality",
		"(fr)Name",
		"(fr)Rank",
		"(fr)Kills",
		"(fr)Assists",
		"(fr)Friendly kills",
		"(fr)Missions flown",
		"(fr)Flight time",
		"(fr)Last flown",
		"(fr)Primary shots fired",
		"(fr)Primary shots hit",
		"(fr)Primary hit %",
		"(fr)Secondary shots fired",
		"(fr)Secondary shots hit",
		"(fr)Secondary hit %",
		"(fr)Primary friendly hits",
		"(fr)Primary friendly hit %",
		"(fr)Secondary friendly hits",
		"(fr)Secondary friendly hit %",
		"(fr)Select",
		"(fr)All",
		"(fr)Select",
		"(fr)Weapons",
		"(fr)Detect 32 bit",
		"(fr)Detect hi-res",
		"(fr)PXO Account",
		"(fr)Login",
		"(fr)Password",
		"(fr)Skip version check in PXO",
		"(fr)PXO Banners",
		"(fr)Misc",
		"(fr)Force local port",
		"(fr)German",
		"(fr)English",
		"(fr)NEW USER TIP\n\n%s",
		"(fr)Flak turret",
		"(fr)Beam turret",
		"(fr)Laser turret",
		"(fr)Missile lnchr"		
	}
};

#endif // MAKE_FS1
